/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "grammar.y" /* yacc.c:339  */


/*
 * ufdbGuard is copyrighted (C) 2005-2020 by URLfilterDB B.V. with all rights reserved.
 *
 * Parts of the ufdbGuard daemon are based on squidGuard.
 * squidGuard is copyrighted (C) 1998 by
 * ElTele st AS, Oslo, Norway, with all rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License (version 2) as
 * published by the Free Software Foundation.  It is distributed in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License (GPL) for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * (GPL2) along with this program.
 */

#define YYMALLOC  ufdbMalloc
#define YYFREE    ufdbFree

#define UFDB_LOG_USER_QUOTA   0   /* TODO remove */

#undef UFDB_DEBUG_ACL_ACCESS
#define UFDB_DEBUG_ACL_ACCESS 1

#include "ufdb.h"
#include "sg.h"
#include "ufdb_globals.h"
#include "ufdblib.h"
#include "ufdbdb.h"
#include "ufdbchkport.h"

#define UFDB_DEBUG 1

#if UFDB_DEBUG
#undef YYDEBUG
#define YYDEBUG 1
#endif

#define UFDB_TIME_DEBUG 0

#if __linux__
#include <sys/mman.h>
#endif
#include <pthread.h>
#include <sys/types.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <netdb.h>
#include <grp.h>
#include <syslog.h>
#include <signal.h>
#include <sched.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <unistd.h>
#include <sys/socket.h>


extern FILE * yyin;
extern FILE * yyout;

int    lineno;

static int   numTimeElements = 0;
static int * TimeElementsEvents = NULL;

static int   time_switch = 0;
static int   date_switch = 0;

static void setDBhome( char * dbhome );
static void setAdministrator( char * value );
static void setLogdir( char * value );
static void setPidfile( char * value );
static void setRefreshUserlist( int nmin );
static void setRefreshDomainlist( int nmin );
static void setRefreshIPlist( int nmin );
static void ufdbSourceExecIPList( char * command );

static void ufdbSourceGroup( int groupType, char * groupName );
static void ufdbSourceUserQuota( const char * seconds, const char * sporadic, const char * renew );
static void ufdbSourceUser( char * user );
static void ufdbSourceUserList( char * file );
static void ufdbSourceExecUserList( char * command );

static void defSource( char * source );
static void defSourceEnd( void );
static struct Source * defSourceFindName( struct Source * slist, const char * name );
static void defSourceDomain( char * );
static void ufdbSourceEval( int method  );
static void defSourceIPV4List( char * file );
static void defSourceIPV6List( char * file );

static void ufdbCategoryCACertsFile( char * cacertsFile );
static void ufdbCategoryCACertsDir( char * cacertsDir );

static void sgIpv4( const char * name, int type, const char * file, int lineno );
static void sgIpv6( const char * addr, int type, const char * file, int line );

void ufdbFreeDomainDb( struct sgDb * dbp );

static void   ufdbAcl( const char * name, const char * value, int within );
static void   ufdbAclSetValue( const char * what, const char * value, int allowed );

static void   sgTime( char * );
static struct ufdbTime * sgTimeFindName( const char * name );
static void   sgTimeElementInit( void );
static void   sgTimeElementAdd( char *, char );
static void   sgTimeElementEnd( void );
static void   sgTimeElementClone( void );
static void   defSourceTime( char * name, int within );

static void   ufdbCategoryTime( char * name, int within );
static void   ufdbCategoryActiveBumping( int flag );
static void   ufdbCategoryBlockConnect( int flag );
static void   ufdbCategoryRewrite( char * value );
static void   ufdbCategoryRedirect( char * value );
static void   ufdbCategoryExecDomainList( char * command );

static void   ufdbCategoryUrlList( char * urllist );
static void   ufdbCategoryOption( int value, int option );

static void   sgRewrite( char * rewrite );
static void   sgRewriteTime( char * name, int within );
static void   sgRewriteSubstitute( char * string );
static struct sgRewrite * sgRewriteFindName( const char * name );

static void   logConfig( void );


#line 201 "grammar.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "grammar.tab.h".  */
#ifndef YY_YY_GRAMMAR_TAB_H_INCLUDED
# define YY_YY_GRAMMAR_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    ADMINISTRATOR = 258,
    QSTRING = 259,
    CHECK_PROXY_TUNNELS = 260,
    QUEUE_CHECKS = 261,
    AGGRESSIVE = 262,
    LOG_ONLY = 263,
    ON = 264,
    OFF = 265,
    CHAR_MINUS = 266,
    CHAR_I = 267,
    CHAR_EXCLAMATION = 268,
    IGNORECASE = 269,
    COMMA = 270,
    EQUAL = 271,
    PORT = 272,
    HTTP_SERVER = 273,
    INTERFACE = 274,
    IMAGES = 275,
    HTTPS_PROHIBIT_INSECURE_SSLV2 = 276,
    HTTPS_PROHIBIT_INSECURE_SSLV3 = 277,
    HTTPS_CONNECTION_CACHE_SIZE = 278,
    IDENTIFIER = 279,
    WORD = 280,
    END = 281,
    START_BRACKET = 282,
    STOP_BRACKET = 283,
    WEEKDAY = 284,
    CATEGORY = 285,
    REWRITE = 286,
    ACL = 287,
    CPUS = 288,
    TIME = 289,
    TVAL = 290,
    DVAL = 291,
    DVALCRON = 292,
    BLOCK_BUMPED_CONNECT = 293,
    EVALUATE_AND = 294,
    EVALUATE_OR = 295,
    SOURCE = 296,
    CONTINUE = 297,
    IPV4ADDR = 298,
    IPV4NET = 299,
    IPV4CLASS = 300,
    IPV4RANGE = 301,
    IPV6ADDR = 302,
    IPV6NET = 303,
    DBHOME = 304,
    DOMAINLIST = 305,
    EXECDOMAINLIST = 306,
    REFRESHDOMAINLIST = 307,
    URLLIST = 308,
    EXPRESSIONLIST = 309,
    CACERTS = 310,
    CACERTSDIR = 311,
    IPV4 = 312,
    IPV4LIST = 313,
    IPV6 = 314,
    IPV6LIST = 315,
    DOMAIN = 316,
    UNIX = 317,
    LDAP = 318,
    USER = 319,
    USERLIST = 320,
    EXECUSERLIST = 321,
    REFRESHUSERLIST = 322,
    EXECIPLIST = 323,
    REFRESHIPLIST = 324,
    USERQUOTA = 325,
    GROUP = 326,
    NL = 327,
    NUMBER = 328,
    NUMBERS = 329,
    PASS = 330,
    REDIRECT = 331,
    SUBST = 332,
    CHAR = 333,
    MINUTELY = 334,
    HOURLY = 335,
    DAILY = 336,
    WEEKLY = 337,
    DATE = 338,
    REDIRECT_FATAL_ERROR = 339,
    REDIRECT_LOADING_DATABASE = 340,
    REDIRECT_HTTPS = 341,
    REDIRECT_BUMPED_HTTPS = 342,
    WITHIN = 343,
    OUTSIDE = 344,
    ELSE = 345,
    ANONYMOUS = 346,
    SPORADIC = 347,
    PIDFILE = 348,
    LOGFILE = 349,
    LOGDIR = 350,
    LOGPASS = 351,
    LOGBLOCK = 352,
    LOGALL = 353,
    LOGALL_HTTPD = 354,
    MAIL_SERVER = 355,
    MY_HOSTNAME = 356,
    ADMIN_EMAIL = 357,
    SENDER_EMAIL = 358,
    EXTERNAL_STATUS_COMMAND = 359,
    TOKEN_ALLOW = 360,
    TOKEN_DENY = 361,
    YOUTUBE_EDUFILTER = 362,
    YOUTUBE_EDUFILTER_ID = 363,
    ALLOW_GOOGLE_HTTPS_USING_IP = 364,
    URL_LOOKUP_RESULT_DB_RELOAD = 365,
    URL_LOOKUP_RESULT_FATAL_ERROR = 366,
    URL_LOOKUP_DELAY_DB_RELOAD = 367,
    OPTION = 368,
    UFDB_SHOW_URL_DETAILS = 369,
    UFDB_LOG_URL_DETAILS = 370,
    SQUID_VERSION = 371,
    SQUID_USES_ACTIVE_BUMPING = 372,
    UPLOAD_CRASH_REPORTS = 373,
    LOOKUP_REVERSE_IP = 374,
    USE_IPV6_ON_WAN = 375,
    PARSE_URL_PARAMETERS = 376,
    STRIP_DOMAIN_FROM_USERNAME = 377,
    UFDB_DEBUG_FILTER = 378,
    UFDB_DEBUG_COREDUMP = 379,
    MADVISE_HUGEPAGES = 380,
    FAST_REFRESH = 381,
    UFDB_DEBUG_SKYPE_PROBES = 382,
    UFDB_DEBUG_GTALK_PROBES = 383,
    UFDB_DEBUG_YAHOOMSG_PROBES = 384,
    UFDB_DEBUG_AIM_PROBES = 385,
    UFDB_DEBUG_FBCHAT_PROBES = 386,
    UFDB_DEBUG_CITRIXONLINE_PROBES = 387,
    UFDB_EXPRESSION_OPTIMISATION = 388,
    UFDB_EXPRESSION_DEBUG = 389,
    UFDB_DEBUG_EXTERNAL_SCRIPTS = 390,
    UFDB_NUM_WORKER_THREADS = 391,
    ENFORCE_HTTPS_WITH_HOSTNAME = 392,
    ENFORCE_HTTPS_OFFICAL_CERTIFICATE = 393,
    ALLOW_SKYPE_OVER_HTTPS = 394,
    ALLOW_UNKNOWN_PROTOCOL_OVER_HTTPS = 395,
    ALLOW_GTALK_OVER_HTTPS = 396,
    ALLOW_YAHOOMSG_OVER_HTTPS = 397,
    ALLOW_AIM_OVER_HTTPS = 398,
    ALLOW_FBCHAT_OVER_HTTPS = 399,
    ALLOW_CITRIXONLINE_OVER_HTTPS = 400,
    ALLOW_ANYDESK_OVER_HTTPS = 401,
    ALLOW_TEAMVIEWER_OVER_HTTPS = 402,
    ANALYSE_UNCATEGORISED = 403,
    LOG_UNCATEGORISED_URLS = 404,
    UPLOAD_STATS = 405,
    SAFE_SEARCH = 406,
    MAX_LOGFILE_SIZE = 407
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 136 "grammar.y" /* yacc.c:355  */

  char * string;
  char * tval;
  char * dval;
  char * dvalcron;
  int    integer;

#line 402 "grammar.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_GRAMMAR_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 419 "grammar.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   558

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  153
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  118
/* YYNRULES -- Number of rules.  */
#define YYNRULES  344
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  508

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   407

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   226,   226,   230,   231,   235,   240,   241,   245,   246,
     247,   251,   255,   259,   263,   267,   271,   275,   279,   283,
     287,   288,   293,   297,   303,   309,   315,   322,   323,   324,
     325,   329,   333,   337,   338,   342,   347,   352,   357,   361,
     365,   369,   374,   397,   402,   407,   412,   417,   422,   426,
     430,   434,   438,   442,   446,   450,   454,   458,   462,   466,
     470,   474,   478,   482,   487,   488,   492,   493,   497,   508,
     520,   524,   525,   529,   534,   539,   544,   549,   554,   561,
     566,   574,   581,   586,   598,   599,   605,   611,   612,   613,
     617,   618,   622,   626,   627,   629,   631,   633,   638,   642,
     643,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   692,   694,   696,   701,   705,
     709,   710,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   729,   731,   733,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     748,   751,   754,   757,   762,   763,   764,   765,   769,   770,
     771,   772,   776,   779,   780,   784,   785,   786,   790,   792,
     791,   797,   798,   802,   810,   811,   812,   813,   814,   817,
     820,   823,   829,   830,   831,   832,   833,   834,   838,   839,
     840,   844,   846,   848,   850,   855,   856,   857,   861,   863,
     868,   869,   873,   877,   878,   883,   884,   885,   886,   889,
     892,   895,   902,   906,   910,   911,   916,   916,   916,   917,
     917,   917,   918,   918,   918,   919,   919,   920,   924,   924,
     925,   929,   930,   931,   932,   933,   934,   937,   940,   943,
     947,   953,   954,   958,   959,   960,   961,   962,   963,   964,
     965,   966,   967,   968,   969,   970,   971,   972,   973,   974,
     975,   976,   977,   978,   979,   980,   981,   982,   983,   984,
     985,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,
    1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,
    1025,  1026,  1027,  1028,  1029
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ADMINISTRATOR", "QSTRING",
  "CHECK_PROXY_TUNNELS", "QUEUE_CHECKS", "AGGRESSIVE", "LOG_ONLY", "ON",
  "OFF", "CHAR_MINUS", "CHAR_I", "CHAR_EXCLAMATION", "IGNORECASE", "COMMA",
  "EQUAL", "PORT", "HTTP_SERVER", "INTERFACE", "IMAGES",
  "HTTPS_PROHIBIT_INSECURE_SSLV2", "HTTPS_PROHIBIT_INSECURE_SSLV3",
  "HTTPS_CONNECTION_CACHE_SIZE", "IDENTIFIER", "WORD", "END",
  "START_BRACKET", "STOP_BRACKET", "WEEKDAY", "CATEGORY", "REWRITE", "ACL",
  "CPUS", "TIME", "TVAL", "DVAL", "DVALCRON", "BLOCK_BUMPED_CONNECT",
  "EVALUATE_AND", "EVALUATE_OR", "SOURCE", "CONTINUE", "IPV4ADDR",
  "IPV4NET", "IPV4CLASS", "IPV4RANGE", "IPV6ADDR", "IPV6NET", "DBHOME",
  "DOMAINLIST", "EXECDOMAINLIST", "REFRESHDOMAINLIST", "URLLIST",
  "EXPRESSIONLIST", "CACERTS", "CACERTSDIR", "IPV4", "IPV4LIST", "IPV6",
  "IPV6LIST", "DOMAIN", "UNIX", "LDAP", "USER", "USERLIST", "EXECUSERLIST",
  "REFRESHUSERLIST", "EXECIPLIST", "REFRESHIPLIST", "USERQUOTA", "GROUP",
  "NL", "NUMBER", "NUMBERS", "PASS", "REDIRECT", "SUBST", "CHAR",
  "MINUTELY", "HOURLY", "DAILY", "WEEKLY", "DATE", "REDIRECT_FATAL_ERROR",
  "REDIRECT_LOADING_DATABASE", "REDIRECT_HTTPS", "REDIRECT_BUMPED_HTTPS",
  "WITHIN", "OUTSIDE", "ELSE", "ANONYMOUS", "SPORADIC", "PIDFILE",
  "LOGFILE", "LOGDIR", "LOGPASS", "LOGBLOCK", "LOGALL", "LOGALL_HTTPD",
  "MAIL_SERVER", "MY_HOSTNAME", "ADMIN_EMAIL", "SENDER_EMAIL",
  "EXTERNAL_STATUS_COMMAND", "TOKEN_ALLOW", "TOKEN_DENY",
  "YOUTUBE_EDUFILTER", "YOUTUBE_EDUFILTER_ID",
  "ALLOW_GOOGLE_HTTPS_USING_IP", "URL_LOOKUP_RESULT_DB_RELOAD",
  "URL_LOOKUP_RESULT_FATAL_ERROR", "URL_LOOKUP_DELAY_DB_RELOAD", "OPTION",
  "UFDB_SHOW_URL_DETAILS", "UFDB_LOG_URL_DETAILS", "SQUID_VERSION",
  "SQUID_USES_ACTIVE_BUMPING", "UPLOAD_CRASH_REPORTS", "LOOKUP_REVERSE_IP",
  "USE_IPV6_ON_WAN", "PARSE_URL_PARAMETERS", "STRIP_DOMAIN_FROM_USERNAME",
  "UFDB_DEBUG_FILTER", "UFDB_DEBUG_COREDUMP", "MADVISE_HUGEPAGES",
  "FAST_REFRESH", "UFDB_DEBUG_SKYPE_PROBES", "UFDB_DEBUG_GTALK_PROBES",
  "UFDB_DEBUG_YAHOOMSG_PROBES", "UFDB_DEBUG_AIM_PROBES",
  "UFDB_DEBUG_FBCHAT_PROBES", "UFDB_DEBUG_CITRIXONLINE_PROBES",
  "UFDB_EXPRESSION_OPTIMISATION", "UFDB_EXPRESSION_DEBUG",
  "UFDB_DEBUG_EXTERNAL_SCRIPTS", "UFDB_NUM_WORKER_THREADS",
  "ENFORCE_HTTPS_WITH_HOSTNAME", "ENFORCE_HTTPS_OFFICAL_CERTIFICATE",
  "ALLOW_SKYPE_OVER_HTTPS", "ALLOW_UNKNOWN_PROTOCOL_OVER_HTTPS",
  "ALLOW_GTALK_OVER_HTTPS", "ALLOW_YAHOOMSG_OVER_HTTPS",
  "ALLOW_AIM_OVER_HTTPS", "ALLOW_FBCHAT_OVER_HTTPS",
  "ALLOW_CITRIXONLINE_OVER_HTTPS", "ALLOW_ANYDESK_OVER_HTTPS",
  "ALLOW_TEAMVIEWER_OVER_HTTPS", "ANALYSE_UNCATEGORISED",
  "LOG_UNCATEGORISED_URLS", "UPLOAD_STATS", "SAFE_SEARCH",
  "MAX_LOGFILE_SIZE", "$accept", "start", "qidentifier",
  "https_cache_size", "allow_or_deny", "on_or_off", "log_pass",
  "log_block", "log_all", "logall_httpd", "youtube_edufilter",
  "youtube_edufilter_id", "allow_google_https_using_ip",
  "madvise_hugepages", "fast_refresh", "debug_filter", "debug_coredump",
  "enforce_https_with_hostname", "enforce_https_offical_certificate",
  "https_prohibit_insecure_sslv2", "https_prohibit_insecure_sslv3",
  "check_proxy_tunnel_option", "check_proxy_tunnels", "admin_spec",
  "dbhome", "refreshuserlist", "refreshiplist", "refreshdomainlist",
  "url_lookup_result_db_reload", "url_lookup_result_fatal_error",
  "url_lookup_delay_db_reload", "squid_version", "num_worker_threads",
  "upload_crash_reports", "lookup_reverse_ip", "use_ipv6_on_wan",
  "parse_url_parameters", "squid_uses_active_bumping",
  "ufdb_log_url_details", "ufdb_show_url_details",
  "ufdb_debug_skype_probes", "ufdb_debug_gtalk_probes",
  "ufdb_debug_yahoomsg_probes", "ufdb_debug_aim_probes",
  "ufdb_debug_fbchat_probes", "ufdb_debug_citrixonline_probes",
  "ufdb_expression_optimisation", "ufdb_expression_debug",
  "ufdb_debug_external_scripts", "mail_server", "my_hostname",
  "admin_email", "sender_email", "external_status_command", "logdir",
  "pidfile", "port", "interface", "cpus", "upload_stats", "redirect_https",
  "redirect_bumped_https", "redirect_loading_database",
  "redirect_fatal_error", "log_uncategorised_urls",
  "analyse_uncategorised", "strip_domain_from_username", "safe_search",
  "max_logfile_size", "httpd_option", "httpd_options", "http_server_def",
  "category", "category_block", "category_contents", "category_content",
  "source", "source_block", "source_contents", "source_content", "domain",
  "user", "acl_block", "acl_contents", "acl_header", "acl_content", "$@1",
  "access_contents", "access_content", "access_pass", "ipv4s", "ipv4",
  "ipv6s", "ipv6", "rew", "rew_block", "rew_contents", "rew_content",
  "time", "time_block", "time_contents", "time_content", "$@2", "$@3",
  "$@4", "$@5", "$@6", "$@7", "$@8", "ttime", "$@9", "date", "dval",
  "tval", "dvalcron", "an_error", "statements", "statement", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407
};
# endif

#define YYPACT_NINF -392

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-392)))

#define YYTABLE_NINF -259

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -392,    13,    66,  -392,  -392,    -2,    22,   -57,    12,   100,
     358,   358,    -1,    11,   107,    43,    98,    -3,    -3,   124,
       4,    18,    29,  -392,   130,   140,   143,   150,   231,   294,
     358,   358,   358,   358,   153,   156,   209,   217,   219,   358,
     222,   358,    15,    15,   358,   358,   358,   225,   358,   358,
     358,   358,   358,   358,    72,   358,   358,   358,   358,   358,
     358,   358,   358,   358,   358,   358,   358,   163,   358,   358,
      85,   358,   358,   358,   168,  -392,  -392,  -392,  -392,  -392,
    -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,
    -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,
    -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,
    -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,
    -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,
    -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,   218,
    -392,   220,  -392,  -392,   227,  -392,   241,  -392,  -392,  -392,
    -392,  -392,  -392,  -392,  -392,  -392,  -392,   253,  -392,  -392,
    -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,
    -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,
    -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,
    -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,
    -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,
    -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,
    -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,
    -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,
    -392,  -392,  -392,  -392,  -392,  -392,   258,   264,   281,   284,
     275,   206,   398,   456,    48,    73,   240,   203,   302,   253,
    -392,  -392,    41,  -392,  -392,  -392,   304,   265,    -3,   280,
     208,   308,   352,   354,    -3,    -3,     2,   257,  -392,  -392,
    -392,  -392,  -392,  -392,   357,  -392,   410,  -392,   160,  -392,
     413,    -3,    -3,   242,   451,    -3,    -3,    55,  -392,  -392,
    -392,    -3,    -3,    88,  -392,  -392,  -392,   -18,  -392,  -392,
    -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,    -3,    -3,
      47,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,
    -392,   455,   457,  -392,  -392,  -392,  -392,  -392,  -392,  -392,
    -392,  -392,  -392,  -392,   466,  -392,   358,   358,   358,   358,
     358,   356,   412,   358,   358,   358,   358,   358,   358,   358,
     358,   358,   358,   194,  -392,  -392,   196,  -392,  -392,   292,
    -392,   469,   479,   296,  -392,  -392,  -392,  -392,   251,  -392,
    -392,  -392,  -392,  -392,   485,  -392,  -392,  -392,  -392,   504,
    -392,   285,    -3,   300,   214,   303,   307,   246,   508,  -392,
     515,   115,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,
    -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,
    -392,  -392,  -392,  -392,  -392,  -392,   326,  -392,  -392,  -392,
    -392,  -392,   254,  -392,  -392,  -392,  -392,  -392,  -392,   296,
    -392,  -392,  -392,  -392,  -392,  -392,  -392,   343,  -392,  -392,
    -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,    92,   320,
    -392,  -392,  -392,  -392,  -392,   534,  -392,  -392,  -392,   527,
    -392,  -392,  -392,  -392,  -392,  -392,  -392,   320,   320,   320,
     295,  -392,   338,   374,   338,   310,  -392,    10,  -392,  -392,
    -392,  -392,   338,   338,   338,   320,   320,   320,  -392,  -392,
    -392,   338,   375,  -392,   177,   320,  -392,  -392
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
     271,     0,     0,     1,   270,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   343,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   278,   280,   281,   282,   283,
     336,   338,   337,   284,   285,   286,   287,   288,   289,   290,
     291,   279,   277,   292,   320,   321,   322,   301,   302,   300,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   323,   295,   296,
     297,   298,   299,   293,   294,   325,   324,   326,   327,   328,
     329,   330,   331,   333,   332,   335,   334,   339,   276,   273,
     275,     0,   274,   340,     0,   341,     0,   342,   344,   272,
      32,    28,    29,    30,    27,    31,    68,     0,     4,     3,
      70,    69,    10,     8,     9,    25,    26,     5,    97,    94,
      95,    96,    93,   231,   230,   193,    71,    72,   242,   148,
      34,    33,    37,    35,    36,    77,    76,    74,    75,    67,
      66,    65,    64,    11,    12,    13,    14,    59,    60,    61,
      62,    63,    15,    16,    17,     6,     7,    38,    39,    40,
      49,    48,    41,    47,    43,    44,    45,    46,    81,    21,
      20,    22,    18,    19,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    42,    23,    24,    80,    79,    78,    73,
      82,    83,    99,   150,   233,   244,     0,     0,     0,    91,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      92,   192,     0,   201,   194,    98,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   100,   149,
     175,   176,   183,   218,     0,   225,     0,   184,     0,   188,
       0,     0,     0,     0,     0,     0,     0,     0,   151,   232,
     235,     0,     0,     0,   234,   257,   243,   249,   255,   245,
      84,    86,    87,    85,    89,    88,    90,   195,     0,     0,
       0,   122,   121,   103,   102,   101,   104,   107,   106,   105,
     110,     0,     0,   109,   108,   116,   115,   118,   117,   120,
     119,   123,   124,   147,     0,   146,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   169,   171,   170,   172,   174,   173,   152,
     188,     0,     0,   153,   156,   155,   159,   160,     0,   162,
     161,   177,   178,   182,     0,   181,   236,   237,   241,     0,
     240,     0,     0,     0,     0,     0,     0,   198,     0,   212,
       0,     0,   202,   112,   111,   114,   113,   145,   144,   133,
     134,   125,   128,   126,   130,   132,   135,   143,   136,   137,
     138,   139,   140,   141,   142,   127,     0,   221,   224,   223,
     222,   219,     0,   228,   229,   226,   187,   186,   185,   154,
     158,   157,   164,   163,   191,   190,   189,     0,   180,   179,
     239,   238,   247,   250,   253,   267,   269,   256,   262,   266,
     196,   197,   199,   205,   204,   203,   207,   206,   211,     0,
     210,   220,   227,   168,   165,   166,   167,     0,     0,     0,
       0,   268,   261,     0,   265,     0,   213,     0,   217,   214,
     209,   208,   248,   251,   254,   264,     0,     0,   201,   215,
     216,   263,     0,   260,     0,     0,   200,   259
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -392,  -392,    -9,  -392,   345,    -8,  -392,  -392,  -392,  -392,
    -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,
    -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,
    -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,
    -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,
    -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,
    -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,
     131,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,
    -392,    23,  -392,  -392,  -392,  -392,  -392,   -93,  -392,  -392,
    -392,   -11,  -392,   -14,  -392,  -392,  -392,  -392,  -392,  -392,
    -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -392,  -369,
    -392,  -392,   -61,  -391,  -392,  -392,  -392,  -392
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,   446,    75,   207,   165,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,   155,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   249,
     250,   138,   139,   140,   252,   278,   141,   142,   253,   298,
     369,   373,   143,   251,   263,   264,   485,   320,   402,   465,
     363,   431,   366,   435,   144,   145,   254,   304,   146,   147,
     255,   309,   391,   477,   392,   478,   393,   479,   394,   482,
     496,   457,   458,   483,   459,   148,     2,   149
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     161,   158,   150,   166,   172,   174,   158,  -252,   178,   179,
     181,  -246,   168,     3,   158,   158,   156,   499,   169,   190,
     192,   159,   193,   194,   195,   196,   159,   343,   151,   152,
     153,   202,   154,   204,   159,   159,   209,   210,   211,   157,
     213,   214,   215,   216,   217,   218,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   158,
     234,   235,   237,   238,   239,   240,    -2,     4,   317,     5,
     175,     6,   167,   162,   305,   397,   299,   182,   398,   159,
     383,   163,   164,     7,     8,     9,   162,    10,    11,    12,
     484,   183,   158,   344,   163,   164,    13,    14,    15,    16,
      17,   306,   184,   480,   158,   502,   503,    18,   492,   493,
     494,   158,   159,   388,   507,    19,   170,   171,    20,   158,
     205,   206,   399,   400,   159,   300,   501,   481,   158,   318,
     319,   159,   173,    21,   185,    22,   301,   302,    23,   159,
     468,   401,   303,   160,   186,   219,   384,   187,   159,   180,
      24,    25,    26,    27,   188,   307,   308,   197,   236,    28,
     198,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,   176,   177,    39,    40,    41,    42,    43,    44,   389,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,   506,   469,   158,   398,   426,
     158,   432,   158,   199,    70,    71,    72,    73,    74,   330,
     331,   200,   332,   201,   370,   371,   203,   159,   311,   212,
     159,   372,   159,   333,   261,   158,   233,   427,   428,   429,
     430,   241,   262,   433,   434,   242,   312,   243,   313,   315,
     455,   456,   399,   400,   244,   159,   189,   322,   325,   326,
     329,   334,   336,   338,   340,   341,   342,   345,   245,   158,
     246,   401,   247,   248,   256,   365,   323,   368,   346,   347,
     257,   375,   376,   377,   158,   380,   381,   382,   385,   159,
     324,   327,   386,   387,   390,   348,   158,   258,   158,   259,
     158,   433,   434,   260,   159,   328,   158,   436,   158,   395,
     396,   444,   158,   310,   452,   378,   159,   437,   159,   191,
     159,   445,   404,   406,   447,   454,   159,   314,   159,   321,
     460,   455,   159,   335,   461,   408,   462,   498,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   481,   158,   162,   158,   162,
     438,   158,   441,   443,   349,   163,   164,   163,   164,   427,
     428,   429,   430,  -258,   350,   449,   159,   337,   159,   339,
     451,   159,   364,   453,  -129,   497,   505,  -129,   208,   464,
     316,   467,   470,   439,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   504,  -129,  -129,   362,  -129,
    -129,  -129,  -129,   162,   158,   471,   473,   158,   472,   495,
       0,   163,   164,   474,   475,   476,   265,     0,     0,   266,
       0,     0,  -129,     0,   159,   367,     0,   159,   374,     0,
    -131,     0,     0,  -131,  -129,  -129,     0,     0,   267,   268,
    -129,   269,   270,   271,   272,   158,   489,     0,     0,   158,
     491,   158,  -131,  -131,     0,  -131,  -131,  -131,  -131,  -129,
     158,     0,     0,   158,   273,   159,   379,     0,   500,   159,
     403,   159,   405,   158,   279,     0,   274,   275,  -131,   158,
     159,   407,   276,   159,   440,   280,   281,     0,   282,     0,
    -131,  -131,     0,   159,   442,     0,  -131,     0,   158,   159,
     448,   277,   158,   283,   284,   285,   286,   287,   288,   158,
     289,   290,   291,     0,   292,  -131,   293,   294,   159,   450,
       0,   158,   159,   463,     0,     0,     0,     0,   158,   159,
     466,   486,     0,     0,   295,   296,     0,   487,     0,   488,
     297,   159,   490,     0,     0,     0,     0,     0,   159
};

static const yytype_int16 yycheck[] =
{
       9,     4,     4,    11,    13,    14,     4,    25,    17,    18,
      19,    29,     1,     0,     4,     4,    73,     7,     7,    28,
      29,    24,    30,    31,    32,    33,    24,    25,     6,     7,
       8,    39,    10,    41,    24,    24,    44,    45,    46,    27,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,     4,
      68,    69,    70,    71,    72,    73,     0,     1,    27,     3,
      27,     5,    73,     1,     1,    28,    28,    73,    31,    24,
      25,     9,    10,    17,    18,    19,     1,    21,    22,    23,
     459,    73,     4,    91,     9,    10,    30,    31,    32,    33,
      34,    28,    73,    11,     4,   496,   497,    41,   477,   478,
     479,     4,    24,    25,   505,    49,   105,   106,    52,     4,
     105,   106,    75,    76,    24,    77,   495,    35,     4,    88,
      89,    24,    25,    67,     4,    69,    88,    89,    72,    24,
      25,    94,    94,    43,     4,    73,    91,     4,    24,    25,
      84,    85,    86,    87,     4,    82,    83,     4,    73,    93,
       4,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,    73,    74,   107,   108,   109,   110,   111,   112,    91,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,    28,    91,     4,    31,    15,
       4,    15,     4,     4,   148,   149,   150,   151,   152,    11,
      12,     4,    14,     4,    64,    65,     4,    24,    25,     4,
      24,    71,    24,    25,    28,     4,    73,    43,    44,    45,
      46,    73,   251,    47,    48,    27,    43,    27,   257,   258,
      36,    37,    75,    76,    27,    24,    25,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,    27,     4,
      17,    94,    19,    20,    16,   284,    11,   286,    21,    22,
      16,   290,   291,   292,     4,   294,   295,   296,   297,    24,
      25,    11,   301,   302,   303,    38,     4,    16,     4,    15,
       4,    47,    48,    28,    24,    25,     4,    15,     4,   318,
     319,    15,     4,    73,    29,    73,    24,    25,    24,    25,
      24,    25,   331,   332,    73,    25,    24,    25,    24,    25,
      27,    36,    24,    25,    27,   344,    90,    27,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    35,     4,     1,     4,     1,
     369,     4,   371,   372,   107,     9,    10,     9,    10,    43,
      44,    45,    46,    35,   117,   384,    24,    25,    24,    25,
     389,    24,    25,   392,    28,    11,    11,    31,    43,   398,
     259,   400,   401,   370,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   498,    50,    51,   151,    53,
      54,    55,    56,     1,     4,   426,    73,     4,   432,   480,
      -1,     9,    10,    80,    81,    82,    28,    -1,    -1,    31,
      -1,    -1,    76,    -1,    24,    25,    -1,    24,    25,    -1,
      28,    -1,    -1,    31,    88,    89,    -1,    -1,    50,    51,
      94,    53,    54,    55,    56,     4,   465,    -1,    -1,     4,
     469,     4,    50,    51,    -1,    53,    54,    55,    56,   113,
       4,    -1,    -1,     4,    76,    24,    25,    -1,   487,    24,
      25,    24,    25,     4,    28,    -1,    88,    89,    76,     4,
      24,    25,    94,    24,    25,    39,    40,    -1,    42,    -1,
      88,    89,    -1,    24,    25,    -1,    94,    -1,     4,    24,
      25,   113,     4,    57,    58,    59,    60,    61,    62,     4,
      64,    65,    66,    -1,    68,   113,    70,    71,    24,    25,
      -1,     4,    24,    25,    -1,    -1,    -1,    -1,     4,    24,
      25,     7,    -1,    -1,    88,    89,    -1,    13,    -1,    15,
      94,    24,    25,    -1,    -1,    -1,    -1,    -1,    24
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   154,   269,     0,     1,     3,     5,    17,    18,    19,
      21,    22,    23,    30,    31,    32,    33,    34,    41,    49,
      52,    67,    69,    72,    84,    85,    86,    87,    93,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   107,
     108,   109,   110,   111,   112,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     148,   149,   150,   151,   152,   156,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   224,   225,
     226,   229,   230,   235,   247,   248,   251,   252,   268,   270,
       4,     6,     7,     8,    10,   174,    73,    27,     4,    24,
      43,   155,     1,     9,    10,   158,   158,    73,     1,     7,
     105,   106,   155,    25,   155,    27,    73,    74,   155,   155,
      25,   155,    73,    73,    73,     4,     4,     4,     4,    25,
     155,    25,   155,   158,   158,   158,   158,     4,     4,     4,
       4,     4,   158,     4,   158,   105,   106,   157,   157,   158,
     158,   158,     4,   158,   158,   158,   158,   158,   158,    73,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,    73,   158,   158,    73,   158,   158,   158,
     158,    73,    27,    27,    27,    27,    17,    19,    20,   222,
     223,   236,   227,   231,   249,   253,    16,    16,    16,    15,
      28,    28,   155,   237,   238,    28,    31,    50,    51,    53,
      54,    55,    56,    76,    88,    89,    94,   113,   228,    28,
      39,    40,    42,    57,    58,    59,    60,    61,    62,    64,
      65,    66,    68,    70,    71,    88,    89,    94,   232,    28,
      77,    88,    89,    94,   250,     1,    28,    82,    83,   254,
      73,    25,    43,   155,    25,   155,   223,    27,    88,    89,
     240,    25,   155,    11,    25,   155,   155,    11,    25,   155,
      11,    12,    14,    25,   155,    25,   155,    25,   155,    25,
     155,   155,   155,    25,    91,   155,    21,    22,    38,   107,
     117,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   151,   243,    25,   155,   245,    25,   155,   233,
      64,    65,    71,   234,    25,   155,   155,   155,    73,    25,
     155,   155,   155,    25,    91,   155,   155,   155,    25,    91,
     155,   255,   257,   259,   261,   155,   155,    28,    31,    75,
      76,    94,   241,    25,   155,    25,   155,    25,   155,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,    15,    43,    44,    45,
      46,   244,    15,    47,    48,   246,    15,    25,   155,   234,
      25,   155,    25,   155,    15,    25,   155,    73,    25,   155,
      25,   155,    29,   155,    25,    36,    37,   264,   265,   267,
      27,    27,    90,    25,   155,   242,    25,   155,    25,    91,
     155,   244,   246,    73,    80,    81,    82,   256,   258,   260,
      11,    35,   262,   266,   262,   239,     7,    13,    15,   155,
      25,   155,   262,   262,   262,   265,   263,    11,    27,     7,
     155,   262,   266,   266,   240,    11,    28,   266
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   153,   154,   155,   155,   156,   157,   157,   158,   158,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   168,   169,   170,   171,   172,   173,   174,   174,   174,
     174,   175,   176,   177,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   207,   208,   208,   209,   210,
     210,   211,   211,   212,   213,   214,   215,   216,   217,   218,
     218,   219,   220,   221,   222,   222,   222,   222,   222,   222,
     223,   223,   224,   225,   225,   225,   225,   225,   226,   227,
     227,   228,   228,   228,   228,   228,   228,   228,   228,   228,
     228,   228,   228,   228,   228,   228,   228,   228,   228,   228,
     228,   228,   228,   228,   228,   228,   228,   228,   228,   228,
     228,   228,   228,   228,   228,   228,   228,   228,   228,   228,
     228,   228,   228,   228,   228,   228,   228,   228,   229,   230,
     231,   231,   232,   232,   232,   232,   232,   232,   232,   232,
     232,   232,   232,   232,   232,   232,   232,   232,   232,   232,
     232,   232,   232,   232,   232,   232,   232,   232,   232,   232,
     232,   232,   232,   232,   233,   233,   233,   233,   234,   234,
     234,   234,   235,   236,   236,   237,   237,   237,   238,   239,
     238,   240,   240,   241,   241,   241,   241,   241,   241,   241,
     241,   241,   242,   242,   242,   242,   242,   242,   243,   243,
     243,   244,   244,   244,   244,   245,   245,   245,   246,   246,
     247,   247,   248,   249,   249,   250,   250,   250,   250,   250,
     250,   250,   251,   252,   253,   253,   255,   256,   254,   257,
     258,   254,   259,   260,   254,   261,   254,   254,   263,   262,
     262,   264,   264,   264,   264,   264,   264,   265,   266,   267,
     268,   269,   269,   270,   270,   270,   270,   270,   270,   270,
     270,   270,   270,   270,   270,   270,   270,   270,   270,   270,
     270,   270,   270,   270,   270,   270,   270,   270,   270,   270,
     270,   270,   270,   270,   270,   270,   270,   270,   270,   270,
     270,   270,   270,   270,   270,   270,   270,   270,   270,   270,
     270,   270,   270,   270,   270,   270,   270,   270,   270,   270,
     270,   270,   270,   270,   270,   270,   270,   270,   270,   270,
     270,   270,   270,   270,   270
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     1,     1,     1,
       1,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     1,     4,     2,     2,     2,     2,     2,     4,     0,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     3,     3,     3,     3,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     3,     3,     3,     3,     2,
       3,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     2,     2,     4,
       0,     2,     2,     2,     3,     2,     2,     3,     3,     2,
       2,     2,     2,     3,     3,     4,     4,     4,     4,     2,
       2,     2,     2,     2,     2,     1,     1,     2,     2,     3,
       3,     2,     2,     1,     0,     2,     2,     2,     0,     2,
       2,     2,     4,     0,     2,     2,     4,     4,     3,     0,
       8,     0,     2,     2,     2,     2,     2,     2,     3,     3,
       2,     2,     0,     2,     2,     3,     3,     2,     0,     2,
       3,     1,     1,     1,     1,     0,     2,     3,     1,     1,
       2,     2,     4,     0,     2,     1,     2,     2,     3,     3,
       2,     2,     2,     4,     0,     2,     0,     0,     5,     0,
       0,     5,     0,     0,     5,     0,     3,     1,     0,     5,
       3,     2,     1,     4,     3,     2,     1,     1,     1,     1,
       1,     0,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 230 "grammar.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 1969 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 231 "grammar.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 1975 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 235 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.httpsConnectionCacheSize = atoi( (yyvsp[0].string) );
		                                         ufdbFree( (yyvsp[0].string) ); }
#line 1982 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 240 "grammar.y" /* yacc.c:1646  */
    { (yyval.integer) = UFDB_ALLOW; }
#line 1988 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 7:
#line 241 "grammar.y" /* yacc.c:1646  */
    { (yyval.integer) = UFDB_DENY; }
#line 1994 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 245 "grammar.y" /* yacc.c:1646  */
    { (yyval.integer) = 1; }
#line 2000 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 246 "grammar.y" /* yacc.c:1646  */
    { (yyval.integer) = 0; }
#line 2006 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 247 "grammar.y" /* yacc.c:1646  */
    { ufdbLogFatalError( "syntax error at line %d: expected 'on' or 'off'", lineno );   }
#line 2012 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 251 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.logPass = (yyvsp[0].integer); }
#line 2018 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 255 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.logBlock = (yyvsp[0].integer); }
#line 2024 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 259 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.logAllRequests = (yyvsp[0].integer); }
#line 2030 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 263 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.debugHttpd = (yyvsp[0].integer); }
#line 2036 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 267 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.YoutubeEdufilter = (yyvsp[0].integer); }
#line 2042 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 271 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.YoutubeEdufilterID = (yyvsp[0].string); }
#line 2048 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 275 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.allowGoogleHTTPSusingIP = (yyvsp[0].integer); }
#line 2054 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 279 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.madviseHugePages = (yyvsp[0].integer); }
#line 2060 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 283 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.fastRefresh = (yyvsp[0].integer); }
#line 2066 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 287 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.debug = ufdbGV.debug = (yyvsp[0].integer); }
#line 2072 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 288 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.debug = ufdbGV.debug = atoi( (yyvsp[0].string) );
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 2079 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 293 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.debugCoreDump = (yyvsp[0].integer); }
#line 2085 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 298 "grammar.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: option enforce-https-with-hostname must be part of "
                                    "the security category", lineno );  }
#line 2092 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 304 "grammar.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: option enforce-https-official-certificate must be part of "
                                  "the security category", lineno );  }
#line 2099 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 310 "grammar.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: option https-prohibit-insecure-sslv2 must be part of "
                                    "the security category", lineno );  }
#line 2106 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 316 "grammar.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: option https-prohibit-insecure-sslv3 must be part of "
                                    "the security category", lineno );  }
#line 2113 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 322 "grammar.y" /* yacc.c:1646  */
    { (yyval.integer) = UFDB_API_HTTPS_CHECK_OFF; }
#line 2119 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 323 "grammar.y" /* yacc.c:1646  */
    { (yyval.integer) = UFDB_API_HTTPS_CHECK_QUEUE_CHECKS; }
#line 2125 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 324 "grammar.y" /* yacc.c:1646  */
    { (yyval.integer) = UFDB_API_HTTPS_CHECK_AGGRESSIVE; }
#line 2131 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 325 "grammar.y" /* yacc.c:1646  */
    { (yyval.integer) = UFDB_API_HTTPS_LOG_ONLY; }
#line 2137 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 329 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.tunnelCheckMethod = (yyvsp[0].integer); }
#line 2143 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 333 "grammar.y" /* yacc.c:1646  */
    { setAdministrator( (yyvsp[0].string) ); }
#line 2149 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 337 "grammar.y" /* yacc.c:1646  */
    { setDBhome( (yyvsp[0].string) ); }
#line 2155 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 338 "grammar.y" /* yacc.c:1646  */
    { setDBhome( (yyvsp[0].string) ); }
#line 2161 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 342 "grammar.y" /* yacc.c:1646  */
    { setRefreshUserlist( atoi((yyvsp[0].string)) );
		                                ufdbFree( (yyvsp[0].string) ); }
#line 2168 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 347 "grammar.y" /* yacc.c:1646  */
    { setRefreshIPlist( atoi((yyvsp[0].string)) );
		                                ufdbFree( (yyvsp[0].string) ); }
#line 2175 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 352 "grammar.y" /* yacc.c:1646  */
    { setRefreshDomainlist( atoi((yyvsp[0].string)) );
		                                ufdbFree( (yyvsp[0].string) ); }
#line 2182 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 358 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.URLlookupResultDBreload = (yyvsp[0].integer); }
#line 2188 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 362 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.URLlookupResultFatalError = (yyvsp[0].integer); }
#line 2194 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 366 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.URLlookupDelayDBreload = (yyvsp[0].integer); }
#line 2200 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 370 "grammar.y" /* yacc.c:1646  */
    { ufdbFree( ufdbNewGV.SquidVersion );  ufdbNewGV.SquidVersion = (yyvsp[0].string);  }
#line 2206 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 375 "grammar.y" /* yacc.c:1646  */
    { int new_n_workers;
					  /* ONLY increase #workers */
					  new_n_workers = atoi( (yyvsp[0].string) );  
		                          ufdbFree( (yyvsp[0].string) );
					  if (new_n_workers < UFDB_MIN_THREADS)
					  {
					     ufdbLogError( "num-worker-threads must be at least %d",
                                                           UFDB_MIN_THREADS );
					     new_n_workers = UFDB_MIN_THREADS;
					  }
					  else if (new_n_workers > UFDB_MAX_THREADS)
					  {
					     ufdbLogError( "num-worker-threads can be at most %d",
                                                           UFDB_MAX_THREADS );
					     new_n_workers = UFDB_MAX_THREADS;
					  }
					  if (new_n_workers > ufdbNewGV.nWorkers)
					     ufdbNewGV.nWorkers = new_n_workers;
					}
#line 2230 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 398 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.uploadCrashReports = (yyvsp[0].integer);  }
#line 2236 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 403 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.lookupReverseIP = (yyvsp[0].integer);  }
#line 2242 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 408 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.useAlsoIPv6onWan = (yyvsp[0].integer);  }
#line 2248 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 413 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.parseURLparameters = (yyvsp[0].integer);  }
#line 2254 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 418 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.SquidUsesActiveBumping = (yyvsp[0].integer);  }
#line 2260 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 422 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.logURLdetails = (yyvsp[0].integer); }
#line 2266 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 426 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.showURLdetails = (yyvsp[0].integer); }
#line 2272 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 430 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.debugSkype = (yyvsp[0].integer); }
#line 2278 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 434 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.debugGtalk = (yyvsp[0].integer); }
#line 2284 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 438 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.debugYahooMsg = (yyvsp[0].integer); }
#line 2290 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 442 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.debugAim = (yyvsp[0].integer); }
#line 2296 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 446 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.debugFBchat = (yyvsp[0].integer); }
#line 2302 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 450 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.debugCitrixOnline = (yyvsp[0].integer); }
#line 2308 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 454 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.expressionOptimisation = (yyvsp[0].integer); }
#line 2314 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 458 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.debugRegexp = (yyvsp[0].integer); }
#line 2320 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 462 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.debugExternalScripts = (yyvsp[0].integer); }
#line 2326 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 466 "grammar.y" /* yacc.c:1646  */
    { ufdbFree( ufdbNewGV.emailServer ); ufdbNewGV.emailServer = (yyvsp[0].string); }
#line 2332 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 470 "grammar.y" /* yacc.c:1646  */
    { ufdbFree( ufdbNewGV.myHostname ); ufdbNewGV.myHostname = (yyvsp[0].string); }
#line 2338 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 474 "grammar.y" /* yacc.c:1646  */
    { ufdbFree( ufdbNewGV.adminEmail ); ufdbNewGV.adminEmail = (yyvsp[0].string); }
#line 2344 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 478 "grammar.y" /* yacc.c:1646  */
    { ufdbFree( ufdbNewGV.senderEmail ); ufdbNewGV.senderEmail = (yyvsp[0].string); }
#line 2350 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 482 "grammar.y" /* yacc.c:1646  */
    {  ufdbFree( ufdbNewGV.externalStatusCommand );  
		                                       ufdbNewGV.externalStatusCommand = (yyvsp[0].string); }
#line 2357 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 487 "grammar.y" /* yacc.c:1646  */
    { setLogdir( (yyvsp[0].string) ); }
#line 2363 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 488 "grammar.y" /* yacc.c:1646  */
    { setLogdir( (yyvsp[0].string) ); }
#line 2369 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 492 "grammar.y" /* yacc.c:1646  */
    { setPidfile( (yyvsp[0].string) ); }
#line 2375 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 493 "grammar.y" /* yacc.c:1646  */
    { setPidfile( (yyvsp[0].string) ); }
#line 2381 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 497 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.portNum = atoi( (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) ); 
                                         if (ufdbNewGV.portNum <= 0)
                                         {
                                            ufdbLogError( "port number must be > 0, using default port %d",
                                                          UFDB_DAEMON_PORT );
                                            ufdbNewGV.portNum = UFDB_DAEMON_PORT;
                                         }
                                       }
#line 2394 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 508 "grammar.y" /* yacc.c:1646  */
    { 
#if HAVE_UNIX_SOCKETS
                                             ufdbLogError( "ufdbguardd is configured to use UNIX sockets.  "
					                   "\"interface\" is ignored." );
#else
		                             if (strcmp( (yyvsp[0].string), "all" ) == 0)
						strcpy( ufdbNewGV.interface, "all" );    
					     else
					        ufdbLogFatalError( "interface must be \"all\" or IP address" );
#endif
					     ufdbFree( (yyvsp[0].string) );
					   }
#line 2411 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 520 "grammar.y" /* yacc.c:1646  */
    { strcpy( ufdbNewGV.interface, (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) ); }
#line 2417 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 524 "grammar.y" /* yacc.c:1646  */
    { ufdbSetCPU( (yyvsp[0].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 2423 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 525 "grammar.y" /* yacc.c:1646  */
    { ufdbSetCPU( (yyvsp[0].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 2429 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 530 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.uploadStats = (yyvsp[0].integer);   }
#line 2435 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 535 "grammar.y" /* yacc.c:1646  */
    { strcpy( ufdbNewGV.redirectHttps, (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) );  }
#line 2441 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 540 "grammar.y" /* yacc.c:1646  */
    { strcpy( ufdbNewGV.redirectBumpedHttps, (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) );  }
#line 2447 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 545 "grammar.y" /* yacc.c:1646  */
    { strcpy( ufdbNewGV.loadingDatabaseRedirect, (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) );  }
#line 2453 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 550 "grammar.y" /* yacc.c:1646  */
    { strcpy( ufdbNewGV.fatalErrorRedirect, (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) );  }
#line 2459 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 555 "grammar.y" /* yacc.c:1646  */
    {
			ufdbNewGV.logUncategorisedURLs = (yyvsp[0].integer);   
		     }
#line 2467 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 562 "grammar.y" /* yacc.c:1646  */
    { 
			ufdbNewGV.analyseUncategorisedURLs = (yyvsp[0].integer);   
		     }
#line 2475 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 567 "grammar.y" /* yacc.c:1646  */
    {
			ufdbNewGV.analyseUncategorisedURLs = atoi( (yyvsp[0].string) ); 
			ufdbFree( (yyvsp[0].string) ); 
		     }
#line 2484 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 575 "grammar.y" /* yacc.c:1646  */
    {
		        ufdbNewGV.stripDomainFromUsername = (yyvsp[0].integer);
		     }
#line 2492 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 582 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.safeSearch = (yyvsp[0].integer); }
#line 2498 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 587 "grammar.y" /* yacc.c:1646  */
    { 
		       ufdbNewGV.maxLogfileSize = strtoul( (yyvsp[0].string), NULL, 10 );
		       ufdbFree( (yyvsp[0].string) );
		       if (ufdbNewGV.maxLogfileSize < 2 * 1024 * 1024)		// minimum is 2 MB
		          ufdbNewGV.maxLogfileSize = 2 * 1024 * 1024;
		       if (ufdbNewGV.maxLogfileSize > 2000000000)		        // maximum is 2 GB
		          ufdbNewGV.maxLogfileSize = 2000000000;
		     }
#line 2511 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 598 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.httpdPort = atoi( (yyvsp[0].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 2517 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 599 "grammar.y" /* yacc.c:1646  */
    { if (strcmp((yyvsp[0].string),"all")== 0)
						strcpy( ufdbNewGV.httpdInterface, "all" );    
					     else
					        ufdbLogFatalError( "http-server interface must be \"all\" or IP address" );
					     ufdbFree( (yyvsp[0].string) );
					   }
#line 2528 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 605 "grammar.y" /* yacc.c:1646  */
    { if (strcmp((yyvsp[0].string),"all")== 0)
						strcpy( ufdbNewGV.httpdInterface, "all" );    
					     else
					        ufdbLogFatalError( "http-server interface must be \"all\" or IP address" );
					     ufdbFree( (yyvsp[0].string) );
					   }
#line 2539 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 611 "grammar.y" /* yacc.c:1646  */
    { strcpy( ufdbNewGV.httpdInterface, (yyvsp[0].string) );       ufdbFree( (yyvsp[0].string) ); }
#line 2545 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 612 "grammar.y" /* yacc.c:1646  */
    { strcpy( ufdbNewGV.httpdImagesDirectory, (yyvsp[0].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 2551 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 613 "grammar.y" /* yacc.c:1646  */
    { strcpy( ufdbNewGV.httpdImagesDirectory, (yyvsp[0].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 2557 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 626 "grammar.y" /* yacc.c:1646  */
    { ufdbCategory( (yyvsp[0].string) ); }
#line 2563 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 627 "grammar.y" /* yacc.c:1646  */
    { ufdbCategory( ufdbStrdup("aggressive") );
		                         yyerror( (char *) "\"aggressive\" is a keyword and must be surrounded by quotes" ); }
#line 2570 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 629 "grammar.y" /* yacc.c:1646  */
    { ufdbCategory( ufdbStrdup("allow") );
		                         yyerror( (char *) "\"allow\" is a keyword and must be surrounded by quotes" ); }
#line 2577 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 631 "grammar.y" /* yacc.c:1646  */
    { ufdbCategory( ufdbStrdup("deny") );
		                         yyerror( (char *) "\"deny\" is a keyword and must be surrounded by quotes" ); }
#line 2584 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 633 "grammar.y" /* yacc.c:1646  */
    { ufdbCategory( ufdbStrdup("syntax-error") );
		                         yyerror( (char *) "erroneous category definition.  Perhaps the category ID is a reserved word?" ); }
#line 2591 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 639 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryEnd(); }
#line 2597 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 647 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryDomainList( (yyvsp[0].string) ); }
#line 2603 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 648 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryDomainList( (yyvsp[0].string) ); }
#line 2609 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 649 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryDomainList( NULL ); }
#line 2615 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 650 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryExecDomainList( (yyvsp[0].string) ); }
#line 2621 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 651 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryUrlList( (yyvsp[0].string) ); }
#line 2627 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 652 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryUrlList( (yyvsp[0].string) ); }
#line 2633 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 653 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryUrlList( NULL ); }
#line 2639 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 654 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryExpressionList( (yyvsp[0].string), "n" ); }
#line 2645 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 655 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryExpressionList( (yyvsp[0].string), "n" ); }
#line 2651 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 656 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryExpressionList( NULL, NULL ); }
#line 2657 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 657 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryExpressionList( (yyvsp[0].string), "i" ); }
#line 2663 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 658 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryExpressionList( (yyvsp[0].string), "i" ); }
#line 2669 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 659 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryExpressionList( (yyvsp[0].string), "i" ); }
#line 2675 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 660 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryExpressionList( (yyvsp[0].string), "i" ); }
#line 2681 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 661 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryCACertsFile( (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) ); }
#line 2687 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 662 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryCACertsFile( (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) ); }
#line 2693 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 663 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryCACertsDir( (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) ); }
#line 2699 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 664 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryCACertsDir( (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) ); }
#line 2705 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 665 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryRedirect( (yyvsp[0].string) ); }
#line 2711 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 666 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryRedirect( (yyvsp[0].string) ); }
#line 2717 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 667 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryRewrite( (yyvsp[0].string) ); }
#line 2723 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 668 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryRewrite( (yyvsp[0].string) ); }
#line 2729 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 669 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryTime( (yyvsp[0].string), UFDB_ACL_WITHIN ); }
#line 2735 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 670 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryTime( (yyvsp[0].string), UFDB_ACL_OUTSIDE ); }
#line 2741 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 671 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryBlockConnect( (yyvsp[0].integer) ); }
#line 2747 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 672 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryActiveBumping( (yyvsp[0].integer) ); }
#line 2753 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 673 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_SAFE_SEARCH );  }
#line 2759 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 674 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_YOUTUBE_EDUFILTER );  }
#line 2765 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 675 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryOption(  1, UFDB_OPT_HTTPS_WITH_HOSTNAME );  }
#line 2771 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 676 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_HTTPS_WITH_HOSTNAME );  }
#line 2777 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 677 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryOption(  1, UFDB_OPT_HTTPS_OFFICAL_CERTIFICATE );  }
#line 2783 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 678 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_HTTPS_OFFICAL_CERTIFICATE );  }
#line 2789 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 679 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_PROHIBIT_INSECURE_SSLV2 );  }
#line 2795 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 680 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_PROHIBIT_INSECURE_SSLV3 );  }
#line 2801 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 681 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_SKYPE_OVER_HTTPS );  }
#line 2807 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 682 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_GTALK_OVER_HTTPS );  }
#line 2813 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 683 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_YAHOOMSG_OVER_HTTPS );  }
#line 2819 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 684 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_AIM_OVER_HTTPS );  }
#line 2825 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 685 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_FBCHAT_OVER_HTTPS );  }
#line 2831 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 686 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_CITRIXONLINE_OVER_HTTPS );  }
#line 2837 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 687 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_ANYDESK_OVER_HTTPS );  }
#line 2843 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 688 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_TEAMVIEWER_OVER_HTTPS );  }
#line 2849 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 689 "grammar.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_UNKNOWN_PROTOCOL_OVER_HTTPS );  }
#line 2855 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 690 "grammar.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[0].string) ); 
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 2862 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 692 "grammar.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[0].string) ); 
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 2869 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 694 "grammar.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[0].string) ); 
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 2876 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 696 "grammar.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[0].string) ); 
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 2883 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 701 "grammar.y" /* yacc.c:1646  */
    { defSource( (yyvsp[0].string) ); }
#line 2889 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 705 "grammar.y" /* yacc.c:1646  */
    { defSourceEnd(); }
#line 2895 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 717 "grammar.y" /* yacc.c:1646  */
    { ufdbSourceUserList( (yyvsp[0].string) ); }
#line 2901 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 718 "grammar.y" /* yacc.c:1646  */
    { ufdbSourceUserList( (yyvsp[0].string) ); }
#line 2907 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 719 "grammar.y" /* yacc.c:1646  */
    { ufdbSourceUserList( (yyvsp[0].string) ); }
#line 2913 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 720 "grammar.y" /* yacc.c:1646  */
    { ufdbSourceUserList( (yyvsp[0].string) ); }
#line 2919 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 721 "grammar.y" /* yacc.c:1646  */
    { ufdbSourceExecUserList( (yyvsp[0].string) ); }
#line 2925 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 722 "grammar.y" /* yacc.c:1646  */
    { ufdbSourceExecIPList( (yyvsp[0].string) ); }
#line 2931 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 723 "grammar.y" /* yacc.c:1646  */
    { ufdbSourceGroup( UFDB_GROUPTYPE_UNIX, (yyvsp[0].string) ); }
#line 2937 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 724 "grammar.y" /* yacc.c:1646  */
    { ufdbSourceGroup( UFDB_GROUPTYPE_UNIX, (yyvsp[0].string) ); }
#line 2943 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 725 "grammar.y" /* yacc.c:1646  */
    { ufdbSourceGroup( UFDB_GROUPTYPE_UNIX, (yyvsp[0].string) ); }
#line 2949 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 726 "grammar.y" /* yacc.c:1646  */
    { ufdbSourceGroup( UFDB_GROUPTYPE_UNIX, (yyvsp[0].string) ); }
#line 2955 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 727 "grammar.y" /* yacc.c:1646  */
    { ufdbSourceUserQuota( (yyvsp[-2].string), (yyvsp[-1].string), "3600" );  
		                                   ufdbFree( (yyvsp[-2].string) ); ufdbFree( (yyvsp[-1].string) ); }
#line 2962 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 729 "grammar.y" /* yacc.c:1646  */
    { ufdbSourceUserQuota( (yyvsp[-2].string), (yyvsp[-1].string), "86400" );  
		                                   ufdbFree( (yyvsp[-2].string) ); ufdbFree( (yyvsp[-1].string) ); }
#line 2969 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 731 "grammar.y" /* yacc.c:1646  */
    { ufdbSourceUserQuota( (yyvsp[-2].string), (yyvsp[-1].string), "604800" );  
		                                   ufdbFree( (yyvsp[-2].string) ); ufdbFree( (yyvsp[-1].string) ); }
#line 2976 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 733 "grammar.y" /* yacc.c:1646  */
    { ufdbSourceUserQuota( (yyvsp[-2].string), (yyvsp[-1].string), (yyvsp[0].string) );  
		                                   ufdbFree( (yyvsp[-2].string) ); ufdbFree( (yyvsp[-1].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 2983 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 736 "grammar.y" /* yacc.c:1646  */
    { defSourceIPV4List( (yyvsp[0].string) ); }
#line 2989 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 737 "grammar.y" /* yacc.c:1646  */
    { defSourceIPV4List( (yyvsp[0].string) ); }
#line 2995 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 739 "grammar.y" /* yacc.c:1646  */
    { defSourceIPV6List( (yyvsp[0].string) ); }
#line 3001 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 740 "grammar.y" /* yacc.c:1646  */
    { defSourceIPV6List( (yyvsp[0].string) ); }
#line 3007 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 741 "grammar.y" /* yacc.c:1646  */
    { ufdbSourceEval( UFDB_EVAL_AND ); }
#line 3013 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 742 "grammar.y" /* yacc.c:1646  */
    { ufdbSourceEval( UFDB_EVAL_OR ); }
#line 3019 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 743 "grammar.y" /* yacc.c:1646  */
    { defSourceTime( (yyvsp[0].string), UFDB_ACL_WITHIN ); }
#line 3025 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 744 "grammar.y" /* yacc.c:1646  */
    { defSourceTime( (yyvsp[0].string), UFDB_ACL_OUTSIDE ); }
#line 3031 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 745 "grammar.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                 lineno, (yyvsp[0].string) ); 
						   ufdbFree( (yyvsp[0].string) ); }
#line 3039 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 748 "grammar.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                 lineno, (yyvsp[0].string) ); 
						   ufdbFree( (yyvsp[0].string) ); }
#line 3047 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 751 "grammar.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                 lineno, (yyvsp[0].string) ); 
						   ufdbFree( (yyvsp[0].string) ); }
#line 3055 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 754 "grammar.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                 lineno, (yyvsp[0].string) ); 
						   ufdbFree( (yyvsp[0].string) ); }
#line 3063 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 757 "grammar.y" /* yacc.c:1646  */
    { ufdbNewGV.lastSource->cont_search = 1; }
#line 3069 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 763 "grammar.y" /* yacc.c:1646  */
    { defSourceDomain( (yyvsp[0].string) ); }
#line 3075 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 764 "grammar.y" /* yacc.c:1646  */
    { defSourceDomain( (yyvsp[0].string) ); }
#line 3081 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 770 "grammar.y" /* yacc.c:1646  */
    { ufdbSourceUser( (yyvsp[0].string) ); }
#line 3087 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 771 "grammar.y" /* yacc.c:1646  */
    { ufdbSourceUser( (yyvsp[0].string) ); }
#line 3093 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 784 "grammar.y" /* yacc.c:1646  */
    { ufdbAcl( (yyvsp[-1].string), NULL, UFDB_ACL_NONE );  }
#line 3099 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 785 "grammar.y" /* yacc.c:1646  */
    { ufdbAcl( (yyvsp[-3].string), (yyvsp[-1].string), UFDB_ACL_WITHIN );  }
#line 3105 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 786 "grammar.y" /* yacc.c:1646  */
    { ufdbAcl( (yyvsp[-3].string), (yyvsp[-1].string), UFDB_ACL_OUTSIDE ); }
#line 3111 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 792 "grammar.y" /* yacc.c:1646  */
    { ufdbAcl( NULL, NULL, UFDB_ACL_ELSE );    }
#line 3117 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 802 "grammar.y" /* yacc.c:1646  */
    { if (ufdbNewGV.lastAcl != NULL  &&  
                                                      ufdbNewGV.lastAcl->pass == NULL) 
                                                  {
                                                     ufdbLogMessage( "line %d: acl has an empty pass statement."
                                                                     "  Adding 'any'.", lineno );
                                                     ufdbAclSetValue( "pass", ufdbStrdup("any"), 1 );
                                                  }
                                                }
#line 3130 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 810 "grammar.y" /* yacc.c:1646  */
    { ufdbAclSetValue( "rewrite", (yyvsp[0].string), 0 ); }
#line 3136 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 811 "grammar.y" /* yacc.c:1646  */
    { ufdbAclSetValue( "rewrite", (yyvsp[0].string), 0 ); }
#line 3142 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 812 "grammar.y" /* yacc.c:1646  */
    { ufdbAclSetValue( "redirect", (yyvsp[0].string), 0 ); }
#line 3148 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 813 "grammar.y" /* yacc.c:1646  */
    { ufdbAclSetValue( "redirect", (yyvsp[0].string), 0 ); }
#line 3154 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 814 "grammar.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                lineno, (yyvsp[0].string) ); 
						  ufdbFree( (yyvsp[0].string) ); }
#line 3162 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 817 "grammar.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                lineno, (yyvsp[0].string) ); 
						  ufdbFree( (yyvsp[0].string) ); }
#line 3170 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 820 "grammar.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                lineno, (yyvsp[0].string) ); 
						  ufdbFree( (yyvsp[0].string) ); }
#line 3178 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 823 "grammar.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                lineno, (yyvsp[0].string) ); 
						  ufdbFree( (yyvsp[0].string) ); }
#line 3186 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 830 "grammar.y" /* yacc.c:1646  */
    { yyerror( (char *) "\"aggressive\" is a keyword and must be surrounded by quotes" ); }
#line 3192 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 831 "grammar.y" /* yacc.c:1646  */
    { ufdbAclSetValue( "pass", (yyvsp[0].string), 1 ); }
#line 3198 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 832 "grammar.y" /* yacc.c:1646  */
    { yyerror( (char *) "\"aggressive\" is a keyword and must be surrounded by quotes" ); }
#line 3204 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 833 "grammar.y" /* yacc.c:1646  */
    { ufdbAclSetValue( "pass", (yyvsp[0].string), 0 ); }
#line 3210 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 844 "grammar.y" /* yacc.c:1646  */
    { sgIpv4( (yyvsp[0].string), SG_IPTYPE_HOST, ufdbNewGV.configFile, lineno );
		                                  ufdbFree( (yyvsp[0].string) );  }
#line 3217 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 846 "grammar.y" /* yacc.c:1646  */
    { sgIpv4( (yyvsp[0].string), SG_IPTYPE_RANGE, ufdbNewGV.configFile, lineno );
		                                  ufdbFree( (yyvsp[0].string) );  }
#line 3224 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 848 "grammar.y" /* yacc.c:1646  */
    { sgIpv4( (yyvsp[0].string), SG_IPTYPE_CLASS, ufdbNewGV.configFile, lineno );
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 3231 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 850 "grammar.y" /* yacc.c:1646  */
    { sgIpv4( (yyvsp[0].string), SG_IPTYPE_CIDR, ufdbNewGV.configFile, lineno );
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 3238 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 861 "grammar.y" /* yacc.c:1646  */
    { sgIpv6( (yyvsp[0].string), SG_IPV6TYPE_HOST, ufdbNewGV.configFile, lineno );
                                                  ufdbFree( (yyvsp[0].string) );  }
#line 3245 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 863 "grammar.y" /* yacc.c:1646  */
    { sgIpv6( (yyvsp[0].string), SG_IPV6TYPE_CIDR, ufdbNewGV.configFile, lineno );
                                                  ufdbFree( (yyvsp[0].string) );  }
#line 3252 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 868 "grammar.y" /* yacc.c:1646  */
    { sgRewrite( (yyvsp[0].string) ); }
#line 3258 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 869 "grammar.y" /* yacc.c:1646  */
    { sgRewrite( (yyvsp[0].string) ); }
#line 3264 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 883 "grammar.y" /* yacc.c:1646  */
    { sgRewriteSubstitute( (yyvsp[0].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 3270 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 884 "grammar.y" /* yacc.c:1646  */
    { sgRewriteTime( (yyvsp[0].string), UFDB_ACL_WITHIN ); }
#line 3276 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 885 "grammar.y" /* yacc.c:1646  */
    { sgRewriteTime( (yyvsp[0].string), UFDB_ACL_OUTSIDE ); }
#line 3282 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 886 "grammar.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s",
		                                                lineno, (yyvsp[0].string) );
								ufdbFree( (yyvsp[0].string) ); }
#line 3290 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 889 "grammar.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s",
		                                                lineno, (yyvsp[0].string) );
								ufdbFree( (yyvsp[0].string) ); }
#line 3298 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 892 "grammar.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s",
		                                                lineno, (yyvsp[0].string) );
								ufdbFree( (yyvsp[0].string) ); }
#line 3306 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 895 "grammar.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s",
		                                                lineno, (yyvsp[0].string) );
								ufdbFree( (yyvsp[0].string) ); }
#line 3314 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 902 "grammar.y" /* yacc.c:1646  */
    { sgTime( (yyvsp[0].string) ); }
#line 3320 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 916 "grammar.y" /* yacc.c:1646  */
    { sgTimeElementInit(); }
#line 3326 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 916 "grammar.y" /* yacc.c:1646  */
    { sgTimeElementAdd((yyvsp[0].string),T_WEEKDAY); }
#line 3332 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 917 "grammar.y" /* yacc.c:1646  */
    { sgTimeElementInit(); }
#line 3338 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 917 "grammar.y" /* yacc.c:1646  */
    { sgTimeElementAdd((yyvsp[0].string),T_WEEKLY); }
#line 3344 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 918 "grammar.y" /* yacc.c:1646  */
    { sgTimeElementInit(); }
#line 3350 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 918 "grammar.y" /* yacc.c:1646  */
    { sgTimeElementAdd((yyvsp[0].string),T_WEEKLY); }
#line 3356 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 919 "grammar.y" /* yacc.c:1646  */
    { sgTimeElementInit(); }
#line 3362 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 919 "grammar.y" /* yacc.c:1646  */
    { sgTimeElementEnd(); }
#line 3368 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 920 "grammar.y" /* yacc.c:1646  */
    { ufdbLogFatalError( "invalid time specification at line %d", lineno );   }
#line 3374 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 924 "grammar.y" /* yacc.c:1646  */
    { sgTimeElementClone(); }
#line 3380 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 937 "grammar.y" /* yacc.c:1646  */
    { sgTimeElementAdd( (yyvsp[0].string), T_DVAL ); }
#line 3386 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 940 "grammar.y" /* yacc.c:1646  */
    { sgTimeElementAdd( (yyvsp[0].tval), T_TVAL ); }
#line 3392 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 943 "grammar.y" /* yacc.c:1646  */
    { sgTimeElementAdd( (yyvsp[0].string), T_DVALCRON ); }
#line 3398 "grammar.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 947 "grammar.y" /* yacc.c:1646  */
    {  yyerror( (char *) "syntax error" );  
                                   if (ufdbNewGV.serialno > 1  &&  ufdbNewGV.debug)
                                      logConfig(); 
                                }
#line 3407 "grammar.tab.c" /* yacc.c:1646  */
    break;


#line 3411 "grammar.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1032 "grammar.y" /* yacc.c:1906  */


int ufdbReadConfig( 
   const char *      file )
{
   struct Source *   source;
   struct Category * cat;
   struct Acl *      acl;

   lineno = 1;
   ufdbResetCPUs();

   ufdbNewGV.configFile = file;

   yyin = fopen( ufdbNewGV.configFile, "r" );
   if (yyin == NULL) 
   {
      syslog( LOG_ALERT, "%s: cannot open configuration file %s", ufdbNewGV.progname, ufdbNewGV.configFile );
      ufdbLogFatalError( "cannot open configuration file %s", ufdbNewGV.configFile );
      return 0;
   }

   ufdbLogMessage( "configuration file: %s", ufdbNewGV.configFile );

   /* keep the old HTTPS redirection URL.  It is most likely that we need it during the database reload */
   /* dot not reset ufdbNewGV.RedirectHttps and ufdbNewGV.RedirectBumpedHttps. */

   ufdbNewGV.debug = 0;
   ufdbNewGV.debugCoreDump = 0;
   strcpy( ufdbNewGV.interface, "all" );
   ufdbNewGV.portNum = UFDB_DAEMON_PORT;
   ufdbNewGV.nWorkers = UFDB_MIN_THREADS;
   ufdbNewGV.debugHttpd = 0;
   ufdbNewGV.logPass = 0;
   ufdbNewGV.logBlock = 0;
   ufdbNewGV.logAllRequests = 0;
   ufdbNewGV.YoutubeEdufilter = 0;
   ufdbFree( ufdbNewGV.YoutubeEdufilterID );
   ufdbNewGV.YoutubeEdufilterID = NULL;
   ufdbNewGV.allowGoogleHTTPSusingIP = 0;

   /* When a database is reloaded, these variables may NOT be reset since they are used during the reload !! */
   ufdbNewGV.URLlookupDelayDBreload = 0;
   ufdbNewGV.URLlookupResultDBreload = UFDB_ALLOW;
   ufdbNewGV.URLlookupResultFatalError = UFDB_ALLOW;
   strcpy( ufdbNewGV.loadingDatabaseRedirect, "http://cgibin.urlfilterdb.com/cgi-bin/URLblocked.cgi?"
                "category=loading-database" );
   ufdbNewGV.SquidVersion = ufdbStrdup( UFDB_DEFAULT_SQUID_VERSION );

   ufdbNewGV.showURLdetails = 0;
   ufdbNewGV.logURLdetails = 0;
   ufdbNewGV.uploadCrashReports = 1;
   ufdbNewGV.lookupReverseIP = 0;
   ufdbNewGV.useAlsoIPv6onWan = 1;
   ufdbNewGV.debugSkype = 0;
   ufdbNewGV.debugGtalk = 0;
   ufdbNewGV.debugYahooMsg = 0;
   ufdbNewGV.debugAim = 0;
   ufdbNewGV.debugFBchat = 0;
   ufdbNewGV.debugCitrixOnline = 0;
   ufdbNewGV.debugRegexp = 0;
   ufdbNewGV.debugExternalScripts = 0;
   ufdbNewGV.expressionOptimisation = 1;
   ufdbNewGV.refreshUserlistInterval = UFDB_DEFAULT_REFRESH_USERLIST;
   ufdbNewGV.refreshIPlistInterval = UFDB_DEFAULT_REFRESH_IPLIST;
   ufdbNewGV.refreshDomainlistInterval = UFDB_DEFAULT_REFRESH_DOMAINLIST;
   ufdbNewGV.analyseUncategorisedURLs = 1;
   ufdbNewGV.logUncategorisedURLs = 0;
   ufdbNewGV.uploadStats = 1;
   ufdbNewGV.safeSearch = 1;
   ufdbNewGV.skipSafeCategory = 0;
   ufdbNewGV.stripDomainFromUsername = 0;
   ufdbNewGV.tunnelCheckMethod = UFDB_API_HTTPS_CHECK_OFF;
   ufdbNewGV.SquidUsesActiveBumping = 0;
   ufdbNewGV.httpsWithHostname = 0;
   ufdbNewGV.httpsOfficialCertificate = 0;
   ufdbNewGV.unknownProtocolOverHttps = 1;
   ufdbNewGV.httpsNoSSLv2 = 1;
   ufdbNewGV.httpsNoSSLv3 = 1;
   ufdbNewGV.httpdPort = 0;
   ufdbNewGV.dateOfCheckedDB[0] = '\0';
   strcpy( ufdbNewGV.httpdInterface, "all" );
   strcpy( ufdbNewGV.httpdImagesDirectory, "." );
 
   ufdbNewGV.databaseStatus = UFDB_API_STATUS_DATABASE_OK;

   (void) yyparse();		/* parse the configuration file ********************/
   fclose( yyin );

   ufdbNewGV.databaseLoadTime = time( NULL );

   /*
    * For analysis of uncategorised URLs we also load a "checked" category
    * that contains URLs that are reviewed and checked not to be part of
    * any other category.
    */
   char * dbhome;
   char   dbfname[1024];

   dbhome = ufdbNewGV.databaseDirectory;

   /* TODO: check if "checked" was not already loaded... */
   if (ufdbNewGV.analyseUncategorisedURLs > 0)
   {
      int status;
      sprintf( dbfname, "%s/checked/domains.ufdb", dbhome );
      status = UFDBloadDatabase( &ufdbNewGV, &ufdbNewGV.checkedDB, dbfname );
      if (status != UFDB_API_OK  &&  status != UFDB_API_STATUS_DATABASE_OLD)
      {
         ufdbNewGV.checkedDB.mem = NULL;
         ufdbNewGV.checkedDB.index = NULL;
         ufdbNewGV.checkedDB.table.nNextLevels = 0;
         if (ufdbGV.debug)
            ufdbLogMessage( "The URL database appears not be from URLfilterDB. No problem." );
      }
      else
      {
         if (ufdbGV.debug)
            ufdbLogMessage( "table \"checked\" is loaded: %s %8.8s",
                            ufdbNewGV.checkedDB.date, ufdbNewGV.checkedDB.flags );
         sprintf( dbfname, "%s/checked/expressions", dbhome );
         (void) UFDBloadExpressions( &ufdbNewGV.checkedExpressions, dbfname );
         ufdbLogMessage( "The implicitly allowed URL category 'checked' is loaded." );
      }
   }

   if (ufdbNewGV.defaultAcl == NULL)
      ufdbLogFatalError( "\"default\" ACL is not defined" );
   else if (ufdbNewGV.defaultAcl->pass == NULL)
      ufdbLogError( "\"default\" ACL is empty: by default all URLs are blocked." );

   /* A configuration file may have a source definition which is not used in the ACL list.
    * This raises the question "what to do with this ?".
    * If we do nothing, the source is matched but has no ACL definition and is silently skipped.
    * Most likely the administrator overlooked something so a warning is useful.
    */
   source = ufdbNewGV.sourceList;
   if (source == NULL  &&  ufdbNewGV.defaultAcl == NULL)
      ufdbLogFatalError( "There are no sources and there is no default ACL" );

   for ( ; source != NULL;  source = source->next)
   {
      int found;

      found = 0;
      for (acl = ufdbNewGV.aclList;  acl != NULL;  acl = acl->next)
      {
         if (strcmp( acl->name, source->name ) == 0)
	 {
	    found = 1;
	    break;
	 }
      }
      if (!found)
      {
         ufdbLogError( "source \"%s\" has no ACL.  *****\n"
	               "This most likely may lead to unexpected results when the source is matched.  *****\n"
		       "It is strongly suggested to remove the source definition OR add the source to the acl.  *****",
		       source->name );
	 source->active = 0;
      }
      else if (acl->pass == NULL)
      {
         ufdbLogMessage( "source \"%s\" has an empty \"pass\" in its ACL *****", source->name );
      }
   }

   for (cat = ufdbNewGV.catList;  cat != NULL;  cat = cat->next)
   {
      if (cat->options == 0  &&  cat->domainlist == NULL  &&  cat->execdomainlist == NULL  && 
          cat->expressionlist == NULL  &&  cat->rewrite == NULL  &&  cat->name != NULL)
      {
         ufdbLogError( "category \"%s\" has no content definition  *****", cat->name );
      }
   }

   if (ufdbNewGV.adminEmail != NULL  &&  ufdbNewGV.emailServer == NULL)
   {
      ufdbLogError( "No email server is defined; cannot send email to \"%s\"  *****", ufdbNewGV.adminEmail );
   }
   if (ufdbNewGV.adminEmail != NULL  &&  ufdbNewGV.emailServer != NULL  &&  ufdbNewGV.senderEmail == NULL)
   {
      ufdbLogMessage( "WARNING: No sender email address is defined; using \"%s\" as sender",
                      ufdbNewGV.adminEmail );
   }

   if (strncmp( ufdbNewGV.SquidVersion, "5.", 2 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "4.", 2 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "3.5", 3 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "3.4", 3 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "3.3", 3 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "3.2", 3 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "3.1", 3 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "3.0", 3 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "2.7", 3 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "2.6", 3 ) != 0)
   {
      ufdbLogFatalError( "Unsupported Squid version \"%s\"  *****\n"
                         "The supported values for squid-version are: "
                         "5.x, 4.x, 3.5, 3.4, 3.3, 3.2, 3.1, 3.0, 2.7, 2.6  *****\n"
			 "If the version of Squid is higher, it is recommended to upgrade ufdbGuard.  *****\n"
			 "Alternatively set squid-version to the highest supported version",
			 ufdbNewGV.SquidVersion );
   }
   if (strncmp( ufdbNewGV.SquidVersion, "5.", 2 ) == 0  ||
       strncmp( ufdbNewGV.SquidVersion, "4.", 2 ) == 0  ||  
       strncmp( ufdbNewGV.SquidVersion, "3.5", 3 ) == 0  ||  
       strncmp( ufdbNewGV.SquidVersion, "3.4", 3 ) == 0)
      ufdbNewGV.SquidHelperProtocol = UFDB_SQUID_HELPER_PROTOCOL3;
   else if (strncmp( ufdbNewGV.SquidVersion, "2.6", 3 ) == 0  ||  
            strncmp( ufdbNewGV.SquidVersion, "2.7", 3 ) == 0)
      ufdbNewGV.SquidHelperProtocol = UFDB_SQUID_HELPER_PROTOCOL1;
   else
      ufdbNewGV.SquidHelperProtocol = UFDB_SQUID_HELPER_PROTOCOL2;	/* 3.0 - 3.3 */

   BuildImplicitPassLists( &ufdbNewGV );

   return 1;
}


static void setDBhome( char * dbhome )
{
   struct stat dirbuf;

   if (strlen(dbhome) > sizeof(ufdbNewGV.databaseDirectory)-1)
   {
      ufdbLogFatalError( "maximum length for dbhome is %d", (int) sizeof(ufdbNewGV.databaseDirectory)-1 );
      ufdbFree( dbhome );
      return;
   }
   strcpy( ufdbNewGV.databaseDirectory, dbhome );

   if (stat( dbhome, &dirbuf ) != 0)
   {
      ufdbLogFatalError( "dbhome %s: directory does not exist or access rights are insufficient", dbhome );
   }
   else
   {
      if (!S_ISDIR(dirbuf.st_mode))
         ufdbLogFatalError( "dbhome: %s is not a directory", dbhome );
   }

   ufdbFree( dbhome );
}


static void setAdministrator( char * value )
{
   char * p;

   if (strlen(value) > sizeof(ufdbNewGV.administrator)-1)
   {
      ufdbLogError( "maximum length for administrator is %d", (int) sizeof(ufdbNewGV.administrator)-1 );
      return;
   }

   while ((p = (char *) strchr( value, '?' )) != NULL)
      *p = '_';
   while ((p = (char *) strchr( value, '&' )) != NULL)
      *p = '_';

   strcpy( ufdbNewGV.administrator, value );
   ufdbFree( value );
}


static void setLogdir( char * value )
{
   if (ufdbNewGV.logDir != NULL)
      ufdbFree( ufdbNewGV.logDir );
   ufdbNewGV.logDir = value;

   ufdbSetGlobalErrorLogFile( ufdbNewGV.logDir, NULL, 0 );
}


static void setPidfile( char * value )
{
   if (ufdbNewGV.pidFilename != NULL)
      ufdbFree( ufdbNewGV.pidFilename );
   ufdbNewGV.pidFilename = value;
}


static void setRefreshUserlist( int nmin )
{
   if (nmin < 5  ||  nmin > 24*60)
   {
      ufdbLogError( "refreshuserlist must have a value between 5 and %d, resetting to %d.", 
                    24*60, UFDB_DEFAULT_REFRESH_USERLIST );
      nmin = UFDB_DEFAULT_REFRESH_USERLIST;
   }
   ufdbNewGV.refreshUserlistInterval = nmin;
}


static void setRefreshIPlist( int nmin )
{
   if (nmin < 5  ||  nmin > 24*60)
   {
      ufdbLogError( "refreshiplist must have a value between 5 and %d, resetting to %d.", 
                    24*60, UFDB_DEFAULT_REFRESH_IPLIST );
      nmin = UFDB_DEFAULT_REFRESH_IPLIST;
   }
   ufdbNewGV.refreshIPlistInterval = nmin;
}


static void setRefreshDomainlist( int nmin )
{
   if (nmin < 5  ||  nmin > 24*60)
   {
      ufdbLogError( "refreshdomainlist must have a value between 5 and %d, resetting to %d.", 
                    24*60, UFDB_DEFAULT_REFRESH_DOMAINLIST );
      nmin = UFDB_DEFAULT_REFRESH_DOMAINLIST;
   }
   ufdbNewGV.refreshDomainlistInterval = nmin;
}


/*
 * Source functions
 */

static void defSource( 
   char *          source )
{
   struct Source * sp;

   if (ufdbGV.debug)
      ufdbLogMessage( "defSource: defining source \"%s\"", source );

   if ((struct Source *) defSourceFindName(ufdbNewGV.sourceList,source) != NULL)
   {
      ufdbLogFatalError( "line %d: source %s is already defined in configuration file %s",
			 lineno, source, ufdbNewGV.configFile );
      ufdbFree( source );
      return;
   }

   sp = (struct Source *) ufdbMallocAligned( UFDB_CACHELINE_SIZE, sizeof(struct Source) );
   sp->name = source;
   sp->active = 1;
   sp->evaluationMethod = UFDB_EVAL_OR;
   sp->ipv4hosts = NULL;
   sp->ipv4 = NULL;
   sp->ipv6hosts = NULL;
   sp->ipv6 = NULL;
   sp->domainDb = NULL;
   sp->userDb = NULL;
   sp->time = NULL;
   sp->within = UFDB_ACL_NONE;
   sp->cont_search = 0;
   sp->sarg0 = NULL;
   sp->execiplistCommand = NULL;
   sp->next = NULL;
   sp->nblocks = 0;
   sp->nmatches = 0;

   if (ufdbNewGV.sourceList == NULL)
   {
      if (ufdbGV.debug)
         ufdbLogMessage( "defSource: SourceList is set to point to \"%s\"", source );
      ufdbNewGV.sourceList = sp;
      ufdbNewGV.lastSource = sp;
   }
   else
   {
      ufdbNewGV.lastSource->next = sp;
      ufdbNewGV.lastSource = sp;
   }
}


static void defSourceEnd( void )
{
   struct Source * s;

   s = ufdbNewGV.lastSource;
   if (s->ipv4 == NULL  &&  s->ipv4hosts == NULL  &&  
       s->ipv6 == NULL  &&  s->ipv6hosts == NULL  &&
       s->domainDb == NULL  &&  s->userDb == NULL)
   {
      if (s->execiplistCommand == NULL)
      {
	 ufdbLogError( "source \"%s\" missing active content, set inactive  *****", s->name );
	 s->time = NULL;
	 s->active = 0;
      }
      else
	 ufdbLogError( "source \"%s\" has an execiplist command but the list is empty and set inactive   *****",
	               s->name );
   }
}


static void ufdbSourceUser( 
   char *          user )
{
   char *          lc;
   struct Source * sp;

   sp = ufdbNewGV.lastSource;
   if (sp->userDb != NULL  &&  sp->userDb->type != SGDBTYPE_USERLIST)
   {
      ufdbLogFatalError( "user \"%s\" in source \"%s\" on line %d: "
                         "found mix of exec and non-exec userlists", 
                         user, sp->name, lineno );
      return;
   }
   if (sp->userDb == NULL)
   {
      sp->userDb = (struct sgDb *) ufdbMalloc( sizeof(struct sgDb) );
      sp->userDb->dbhome = NULL;
      sp->userDb->dbcp = (void *) UFDBmemDBinit();
      sp->userDb->type = SGDBTYPE_USERLIST;
      sp->userDb->entries = 0;
   }

   for (lc = user;  *lc != '\0';  lc++)    // convert username to lowercase
   {
      if (*lc <= 'Z'  &&  *lc >= 'A')
         *lc += 'a' - 'A';
   }

   if (ufdbGV.debug > 1)
      ufdbLogMessage( "ufdbSourceUser: adding user \"%s\"", user );

   sp->userDb->entries++;
   UFDBmemDBinsert( (struct UFDBmemDB *) sp->userDb->dbcp, user, NULL );
   ufdbFree( user );
}


static void ufdbSourceUnixGroup(
   char *          groupName  )
{
   struct Source * sp;
   struct group *  grp;
   int             n;
   char *          user;

   sp = ufdbNewGV.lastSource;
   if (sp->userDb != NULL  &&  sp->userDb->type != SGDBTYPE_USERLIST)
   {
      ufdbLogFatalError( "unix group \"%s\" in source \"%s\" on line %d: "
                         "found mix of exec and non-exec userlists", 
                         groupName, sp->name, lineno );
      return;
   }
   if (sp->userDb == NULL) 
   {
      sp->userDb = (struct sgDb *) ufdbMalloc( sizeof(struct sgDb) );
      sp->userDb->dbhome = NULL;
      sp->userDb->dbcp = (void *) UFDBmemDBinit();
      sp->userDb->type = SGDBTYPE_USERLIST;
      sp->userDb->entries = 0;
   }
 
   n = 0;
   setgrent();
   errno = 0;
   grp = getgrnam( groupName );
   if (grp != NULL)
   {
      if (ufdbGV.debug > 1)
         ufdbLogMessage( "found group \"%s\"", grp->gr_name );

      while ((user = grp->gr_mem[n]) != NULL)
      {
	 char * lc;

	 if (ufdbGV.debug > 1)
	    ufdbLogMessage( "group \"%s\" has user \"%s\"", grp->gr_name, user );
	 for (lc = user;  *lc != '\0';  lc++)  	// convert username to lowercase
	 {
	    if (*lc <= 'Z'  &&  *lc >= 'A')
	       *lc += 'a' - 'A';
	 }
	 UFDBmemDBinsert( (struct UFDBmemDB *) sp->userDb->dbcp, user, NULL );
	 sp->userDb->entries++;
	 n++;
      }
      ufdbLogMessage( "source \"%s\": unix group \"%s\" has %d members", sp->name, groupName, n );
      if (n == 0)
	 ufdbLogMessage( "WARNING: source \"%s\": \"%s\" is an empty group  +++++", sp->name, groupName );
   }
   else
   {
      ufdbLogFatalError( "source \"%s\": \"%s\" is not a unix group", sp->name, groupName );
      if (errno)
	 ufdbLogError( "ufdbSourceUnixGroup: getgrnam returned error %d: %s", errno, strerror(errno) );
   }
   endgrent();
}


static void ufdbSourceGroup( 
   int    groupType,
   char * groupName  )
{
   switch (groupType)
   {
   case UFDB_GROUPTYPE_UNIX:
      ufdbSourceUnixGroup( groupName );
      break;
   default:     
      ufdbLogFatalError( "ufdbSourceGroup: unknown group type %d", groupType );
   }

   ufdbFree( groupName );
}


struct sgDb * UFDBretrieveExecDomainlist( struct Category * cat )       // uses ufdbGV
{
   char *        t;
   FILE *        fp;
   struct sgDb * newdb;
   int           exitcode;
   struct stat   Stat0;
   struct stat   Stat1;
   char          line[1024];
   char          basefilename[1024];
   char          fullfilename[1024];
   char          command[3000];

   if (cat == NULL)
   {
      ufdbLogFatalError( "UFDBretrieveExecDomainlist: category is NULL" );
      return NULL;
   }

   if (cat->domainlist == NULL)
   {
      ufdbLogError( "will not execute command for category %s since domainlist is undefined", cat->name );
      return NULL;
   }

   if (cat->execdomainlist == NULL)
   {
      ufdbLogError( "can't execute command for category %s since execdomainlist is undefined", cat->name );
      return NULL;
   }

   if (cat->domainlist[0] == '/')
   {
      strcpy( basefilename, cat->domainlist );
   }
   else
   {
      char * dbhome;
      dbhome = ufdbGV.databaseDirectory;
      sprintf( basefilename, "%s/%s", dbhome, cat->domainlist );
   }
   strcpy( fullfilename, basefilename );
   strcat( fullfilename, UFDBfileSuffix );

   if (stat( fullfilename, &Stat0 ) != 0)
   {
      Stat0.st_mtime = 0;
      ufdbLogMessage( "category %s: pre-execdomainlist: domainlist does not exist (%s)",
                      cat->name, fullfilename );
   }

   /* The script that we will call needs the directory where the files reside,
    * so the popen-command contains a "cd" just before executing the script.
    * (note that we are multithreaded and cannot use chdir() here)
    */
   strcpy( command, "cd " );
   strcat( command, basefilename );
   t = strrchr( command, '/' );
   if (t != NULL)
      *t = '\0';
   strcat( command, " ; " );
   strcat( command, cat->execdomainlist );

   errno = 0;
   if ((fp = popen(command,"r")) == NULL)
   {
      ufdbLogFatalError( "category %s: can't execute command of execdomainlist \"%s\": popen failed: %s  *****",
                         cat->name, cat->execdomainlist, strerror(errno) );
      return NULL;
   }

   while (UFDBfgetsNoNL(line,sizeof(line)-1,fp) != NULL)
   {
      ufdbLogMessage( "execdomainlist for %s produced: %s", cat->name, line );
   }
   errno = 0;
   exitcode = pclose( fp );

   if (exitcode == -1  &&  errno == ECHILD)
      exitcode = 0;
      /* most likely the child handler thread already did a wait() */

   if (exitcode == 0)
   {
      if (ufdbGV.debug || ufdbGV.debugExternalScripts)
         ufdbLogMessage( "   execdomainlist for %s: exit 0 (OK)", cat->name );
   }
   else if (exitcode == -1)
   {
      ufdbLogError( "execdomainlist for %s: pclose error: %d (%s)", cat->name, errno, strerror(errno) );
      return NULL;
   }
   else if (exitcode > 0)
   {
      ufdbLogError( "execdomainlist for %s: command (%s) terminated with an error exit code %d", 
                    cat->name, cat->execdomainlist, exitcode );
      return NULL;
   }

   /* The command defined by 'execdomainlist' has been executed and the exit code was 0 (OK), so
    * now it is verified if the file timestamp of domains.ufdb is newer.
    */

   if (stat( fullfilename, &Stat1 ) != 0)
   {
      ufdbLogError( "execdomainlist for %s: command failed to produce a .ufdb file (%s)",
                    cat->name, fullfilename );
      return NULL;
   }

   newdb = (struct sgDb *) ufdbCalloc( sizeof(struct sgDb), 1 );
   newdb->dbhome = NULL;
   newdb->dbcp = NULL;
   newdb->type = SGDBTYPE_DOMAINLIST;

   sgDbInit( newdb, basefilename );
   if (newdb->dbcp == NULL)
   {
      ufdbLogError( "execdomainlist for %s: command produced a .ufdb file but I failed to load it", cat->name );
      ufdbFree( newdb );
      return NULL;
   }

   if (ufdbGV.debug || ufdbGV.debugExternalScripts)
      ufdbLogMessage( "execdomainlist for %s: new URL table is loaded", cat->name );

   return newdb;
}


static void ufdbSourceExecUserList(
   char *          command )            // must be malloced
{
   time_t          t0, te;
   struct Source * sp;

   /* execuserlist is used to dynamically retrieve a list of usernames and
    * is executed every 15 minutes to refresh the list of usernames.
    */

   sp = ufdbNewGV.lastSource;
   if (sp->userDb != NULL  &&  sp->userDb->type != SGDBTYPE_EXECUSERLIST)
   {
      ufdbLogFatalError( "execuserlist \"%s\" in source \"%s\" on line %d: "
                         "found mix of exec and non-exec userlists", 
                         command, sp->name, lineno );
      return;
   }
   if (sp->userDb != NULL)
   {
      ufdbLogFatalError( "execuserlist \"%s\" in source \"%s\" on line %d: "
                         "more than one execuserlist is not supported.  Merge the userlists in the script.", 
                         command, sp->name, lineno );
      return;
   }
   ufdbLogMessage( "execuserlist \"%s\"", command );

   t0 = time( NULL );
   sp->userDb = UFDBretrieveExecUserlist( &ufdbNewGV, command );
   sp->sarg0 = command;				/* command is already malloc-ed */
   te = time( NULL );

   if (te - t0 > 4)
      ufdbLogMessage( "WARNING: it took %ld seconds to execute \"%s\"  *****", te - t0, command );
 
   if (ufdbGV.debug>1 || ufdbGV.debugExternalScripts)
   {
      UFDBmemDBprintUserDB( "user", (struct UFDBmemDB *) sp->userDb->dbcp );
   }
}


static void ufdbSourceExecIPList(
   char *          command )            // must be malloced
{
   time_t          t0, te;
   struct Source * sp;

   /* execiplist is used to dynamically retrieve a list of IP addresses and
    * is executed every 15 minutes to refresh the list of IP addresses.
    */

   sp = ufdbNewGV.lastSource;
   if (sp->ipv4 != NULL  ||  sp->ipv6 != NULL)
   {
      ufdbLogFatalError( "execiplist \"%s\" in source \"%s\" on line %d: "
                         "found mix of exec and non-exec iplists", 
                         command, sp->name, lineno );
      return;
   }
   ufdbLogMessage( "execiplist \"%s\"", command );

   t0 = time( NULL );
   UFDBretrieveExecIPlist( &ufdbNewGV, command, &sp->ipv4hosts, &sp->ipv4, &sp->ipv6hosts, &sp->ipv6 );
   sp->execiplistCommand = command;			/* command is already malloc-ed */
   te = time( NULL );

   if (te - t0 > 4)
      ufdbLogMessage( "WARNING: it took %ld seconds to execute \"%s\"  *****", te - t0, command );
 
   if (ufdbGV.debug>1 || ufdbGV.debugExternalScripts)
   {
      UFDBlogIPv4( sp->ipv4 );
      UFDBlogIPv6( sp->ipv6 );
   }
}


static void ufdbSourceUserList( 
   char * file  )
{
   char * dbhome;
   char * f;
   FILE * fp;
   char * p;
   char * c;
   char * s;
   char * lc;
   char * lineptr;
   int    ullineno;
   struct sgDb * udb;
   struct Source * sp;
   char   line[10000];
 
   sp = ufdbNewGV.lastSource;
   if (ufdbGV.debug)
      ufdbLogMessage( "ufdbSourceUserList: source \"%s\"  file \"%s\"", 
       		      sp->name != NULL ? sp->name : "nosource", file );
   udb = sp->userDb;
   if (udb != NULL  &&  udb->type != SGDBTYPE_USERLIST)
   {
      ufdbLogFatalError( "userlist \"%s\" in source \"%s\" on line %d: "
                         "found mix of exec and non-exec userlists", 
                         file, sp->name, lineno );
      return;
   }
   if (udb == NULL)
   {
      udb = sp->userDb = (struct sgDb *) ufdbMalloc( sizeof(struct sgDb) );
      udb->dbhome = NULL;
      udb->dbcp = (void *) UFDBmemDBinit();
      udb->type = SGDBTYPE_USERLIST;
      udb->entries = 0;
   }
 
   dbhome = ufdbNewGV.databaseDirectory;
 
   if (file[0] == '/')
      f = file;
   else
   {
      f = (char *) ufdbMalloc( strlen(dbhome) + strlen(file) + 2 );
      strcpy( f, dbhome );
      strcat( f, "/" );
      strcat( f, file );
      ufdbFree( file );
   }
 
   if ((fp = fopen(f,"r")) == NULL)
   {
      ufdbLogError( "line %d: can't open userlist %s: %s  *****", lineno, f, strerror(errno) );
      ufdbFree( f );
      return;
   }
   ullineno = 0;
 
   ufdbLogMessage( "userlist \"%s\"", f );
 
   while (fgets(line,sizeof(line),fp) != NULL)
   {
      ullineno++;
      if (line[0] == '#')			/* skip comments */
         continue;
 
      p = strchr( line, '\n' );
      if (p != NULL)
      {
         *p = '\0';
         if (p != line) 
         {
  	    if (*(p - 1) == '\r') 		/* remove ^M  */
  	       *(p-1) = '\0';
         }
      }
  
      if (line[0] == '\0')
      {
         ufdbLogError( "userlist %s: line %d: line is empty", f, ullineno );
         continue;
      }
  
      c = strchr( line, '#' );		        /* remove comment */
      if (c != NULL)
         *c = '\0';
  
      p = strtok_r( line, " \t,", &lineptr );
      if (p == NULL  ||  *p == '\0')
         continue;
  
      /* we may have a passwd-style formatted file. Ignore ':' and everything else that follows. */
      if ((s = strchr(p,':')) != NULL) 
         *s = '\0';
  
      do
      {
         for (lc = p;  *lc != '\0';  lc++)      // convert username to lowercase
         {
  	    if (*lc <= 'Z'  &&  *lc >= 'A')
  	       *lc += 'a' - 'A';
         }
         if (*p != '\0')
 	 {
	    udb->entries++;
  	    UFDBmemDBinsert( (struct UFDBmemDB *) udb->dbcp, p, NULL );
         }
      } while ((p = strtok_r(NULL," \t,",&lineptr)) != NULL  &&  *p != '\0');
   }
   fclose( fp );

   if (ufdbGV.debug > 1)
   {
      ufdbLogMessage( "just read userlist \"%s\"", f );
      UFDBmemDBprintUserDB( "user", (struct UFDBmemDB *) udb->dbcp );
   }

   ufdbFree( f );
}


static void ufdbSourceUserQuota( 
   const char * seconds, 
   const char * sporadic,  
   const char * renew )
{
   if (seconds == NULL || sporadic == NULL || renew == NULL)
      { ; }      // prevent compiler warning

   ufdbLogError( "line %d: userquota is not supported", lineno );
}


static void defSourceDomain( 
   char * domain )
{
   struct Source * sp;

   sp = ufdbNewGV.lastSource;
   if (sp->domainDb == NULL) 
      sp->domainDb = (struct sgDb *) UFDBmemDBinit();

   if (ufdbGV.debug)
      ufdbLogMessage( "defSourceDomain \"%s\"", domain );

   UFDBmemDBinsert( (struct UFDBmemDB *) sp->domainDb, domain, NULL );

   ufdbFree( domain );
}


static void ufdbSourceEval( 
   int method  )
{
   if (ufdbNewGV.lastSource != NULL)
   {
      if (ufdbGV.debug)
         ufdbLogMessage( "ufdbSourceEval %d: %s", method, 
	                 method == UFDB_EVAL_OR ? "evaluate-or" : "evaluate-and" );
      ufdbNewGV.lastSource->evaluationMethod = method;
   }
}


static void defSourceTime( 
   char *         name, 
   int            within )
{
   struct ufdbTime *  t;

   if ((t = sgTimeFindName(name)) == NULL)
   {
      ufdbLogFatalError( "line %d: time \"%s\" is not defined in configuration file %s",
		         lineno, name, ufdbNewGV.configFile );
      ufdbFree( name );
      return;
   }

   ufdbNewGV.lastSource->within = within;
   ufdbNewGV.lastSource->time = t;
   ufdbFree( name );
}


static struct Source * defSourceFindName( 
   struct Source * slist,
   const char *    name )
{
   for ( ;  slist != NULL;  slist = slist->next)
   {
      if (strcmp(name,slist->name) == 0)
         return slist;
   }
   return NULL;
}


static void defSourceIPV4List( 
   char * file )
{
   char * dbhome;
   char * f;
   FILE * fp;
   char * p;
   char * c;
   char * cidr;
   int    i;
   int    l = 0;
   char * lineptr;
   char   line[UFDB_MAX_URL_LENGTH];

   dbhome = ufdbNewGV.databaseDirectory;

   if (file[0] == '/') 
   {
      f = file;
   }
   else
   {
      f = (char *) ufdbMalloc( strlen(dbhome) + strlen(file) + 2 );
      strcpy( f, dbhome );
      strcat( f, "/" );
      strcat( f, file );
      ufdbFree( file );
   }

   if ((fp = fopen(f,"r")) == NULL) 
   {
      ufdbLogError( "line %d: can't open ipv4list %s: %s", lineno, f, strerror(errno) );
      ufdbFree( f );
      return;
   }

   ufdbLogMessage( "ipv4list \"%s\"", f );

   while (fgets(line,sizeof(line),fp) != NULL)
   {
      l++;
      if (*line == '#')
         continue;
      p = strchr( line, '\n' );
      if (p != NULL && p != line) 
      {
         if (*(p - 1) == '\r') 		        // remove ^M
            p--;
         *p = '\0';
      }
      c = strchr( line, '#' );
      p = strtok_r( line, " \t,", &lineptr );
      do {
         if (c != NULL && p >= c) 		// find the comment
            break;
         i = strspn( p, ".0123456789/-" );
         if (i == 0)
            break;
         *(p + i) = '\0';
         if ((cidr = strchr(p,'/')) != NULL) 
         {
            *cidr = '\0';
            cidr++;
            if (strchr(cidr,'.') == NULL)
               sgIpv4( p, SG_IPTYPE_CIDR, f, l );
            else 
               sgIpv4( p, SG_IPTYPE_CLASS, f, l );
          }
          else if ((cidr = strchr(p,'-')) != NULL) 
          {
             sgIpv4( p, SG_IPTYPE_RANGE, f, l );
          }
          else
          {
             sgIpv4( p, SG_IPTYPE_HOST, f, l );
          }
      } while ((p = strtok_r(NULL," \t,",&lineptr)) != NULL);
   }

   fclose( fp );
   ufdbFree( f );
}


static void defSourceIPV6List( 
   char * file )
{
   char * dbhome;
   char * f;
   FILE * fp;
   char * p;
   char * c;
   int    i;
   int    l = 0;
   char * lineptr;
   char   line[UFDB_MAX_URL_LENGTH];

   dbhome = ufdbNewGV.databaseDirectory;

   if (file[0] == '/') 
   {
      f = file;
   }
   else
   {
      f = (char *) ufdbMalloc( strlen(dbhome) + strlen(file) + 2 );
      strcpy( f, dbhome );
      strcat( f, "/" );
      strcat( f, file );
      ufdbFree( file );
   }

   if ((fp = fopen(f,"r")) == NULL) 
   {
      ufdbLogError( "line %d: can't open ipv6list %s: %s", lineno, f, strerror(errno) );
      ufdbFree( f );
      return;
   }

   ufdbLogMessage( "ipv6list \"%s\"", f );

   while (fgets(line,sizeof(line),fp) != NULL)
   {
      l++;
      if (*line == '#')
         continue;
      p = strchr( line, '\n' );
      if (p != NULL && p != line) 
      {
         if (*(p - 1) == '\r') 		        // remove ^M
            p--;
         *p = '\0';
      }
      c = strchr( line, '#' );
      p = strtok_r( line, " \t,", &lineptr );
      do {
         if (c != NULL && p >= c) 		// find the comment
            break;
         i = strspn( p, ":.0123456789ABCDEFabcdef/" );
         if (i == 0)
            break;
         *(p + i) = '\0';
         if (strchr(p,'/') != NULL) 
         {
            sgIpv6( p, SG_IPV6TYPE_CIDR, f, l );
         }
         else
         {
            sgIpv6( p, SG_IPV6TYPE_HOST, f, l );
         }
      } while ((p = strtok_r(NULL," \t,",&lineptr)) != NULL);
   }

   fclose( fp );
   ufdbFree( f );
}


/* category block functions */

void ufdbCategory( 
  char *            cat )
{
  struct Category * sp;

#if UFDB_DEBUG
   ufdbLogMessage( "ufdbCategory %s", cat );
#endif

  if (ufdbNewGV.catList != NULL) 
  {
    if ((struct Category *) ufdbCategoryFindByName(&ufdbNewGV,cat) != NULL)
    {
      ufdbLogFatalError( "line %d: category %s is already defined in configuration file %s",
		         lineno, cat, ufdbNewGV.configFile );
      ufdbFree( cat );
      return;
    }
  }

  sp = (struct Category *) ufdbMallocAligned( UFDB_CACHELINE_SIZE, sizeof(struct Category) );
  sp->active = 1;
  sp->within = UFDB_ACL_NONE;
  sp->activeBumping = UFDB_ACTIVE_BUMPING_NOTSET;
  sp->blockBumpedConnect = 0;
  sp->options = 0;
  sp->name = cat;
  sp->domainlist = NULL;
  sp->domainlistDb = NULL;
  sp->execdomainlist = NULL;
  sp->expressionlist = NULL;
  sp->regExp = NULL;
  sp->redirect = NULL;
  sp->time = NULL;
  sp->rewrite = NULL;
  sp->next = NULL;
  sp->nblocks = 0;
  sp->nmatches = 0;

  if (ufdbNewGV.catList == NULL) {
    ufdbNewGV.catList = sp;
    ufdbNewGV.lastCat = sp;
  } else {
    ufdbNewGV.lastCat->next = sp;
    ufdbNewGV.lastCat = sp;
  }

   /* category "security" is a special case: the options cannot be set default to 0
    * because the default value for allow-unknown-protocol-over-https is ON.
    */
   if (strcmp( cat, "security" ) == 0)
      sp->options = UFDB_OPT_UNKNOWN_PROTOCOL_OVER_HTTPS;
}


void ufdbCategoryEnd( void )
{
  struct Category * d;
 
  d = ufdbNewGV.lastCat;
  if (d->domainlist == NULL  &&  d->expressionlist == NULL  && 
      d->redirect == NULL  &&  d->rewrite == NULL  &&
      d->options == 0)
  {
    ufdbLogError( "category \"%s\" is missing content, set inactive  *****", d->name );
    d->time = NULL;
    d->active = 0;
  }
}


static void ufdbCategoryOption( int value, int option )
{
   struct Category * sp;

   sp = ufdbNewGV.lastCat;
   if (value)
      sp->options = sp->options | option;
   else
      sp->options = sp->options & (~option);

   if (option == UFDB_OPT_HTTPS_WITH_HOSTNAME)
      ufdbNewGV.httpsWithHostname = value;
   else if (option == UFDB_OPT_HTTPS_OFFICAL_CERTIFICATE)
      ufdbNewGV.httpsOfficialCertificate = value;
   else if (option == UFDB_OPT_SKYPE_OVER_HTTPS)
      ufdbNewGV.SkypeOverHttps = value;
   else if (option == UFDB_OPT_GTALK_OVER_HTTPS)
      ufdbNewGV.GtalkOverHttps = value;
   else if (option == UFDB_OPT_YAHOOMSG_OVER_HTTPS)
      ufdbNewGV.YahooMsgOverHttps = value;
   else if (option == UFDB_OPT_AIM_OVER_HTTPS)
      ufdbNewGV.AimOverHttps = value;
   else if (option == UFDB_OPT_FBCHAT_OVER_HTTPS)
      ufdbNewGV.FBchatOverHttps = value;
   else if (option == UFDB_OPT_CITRIXONLINE_OVER_HTTPS)
      ufdbNewGV.CitrixOnlineOverHttps = value;
   else if (option == UFDB_OPT_ANYDESK_OVER_HTTPS)
      ufdbNewGV.AnydeskOverHttps = value;
   else if (option == UFDB_OPT_TEAMVIEWER_OVER_HTTPS)
      ufdbNewGV.TeamviewerOverHttps = value;
   else if (option == UFDB_OPT_PROHIBIT_INSECURE_SSLV2)
      ufdbNewGV.httpsNoSSLv2 = value;
   else if (option == UFDB_OPT_PROHIBIT_INSECURE_SSLV3)
      ufdbNewGV.httpsNoSSLv3 = value;
   else if (option == UFDB_OPT_UNKNOWN_PROTOCOL_OVER_HTTPS)
      ufdbNewGV.unknownProtocolOverHttps = value;
   else if (option == UFDB_OPT_SAFE_SEARCH)
      ;
   else if (option == UFDB_OPT_YOUTUBE_EDUFILTER)
      ;
   else
      ufdbLogError( "ufdbCategoryOption: unrecognised option %d *****", option );

   if (ufdbGV.debug > 1)
      ufdbLogMessage( "ufdbCategoryOption: %s: option %d set to %d", sp->name, option, value );
}


void ufdbCategoryDomainList( 
  char * domainlist )
{
  struct Category * sp;
  const char *      dbhome;
        char *      dl;
  const char *      name;

  if (ufdbGV.debug > 1)
     ufdbLogMessage( "ufdbCategoryDomainList %s", domainlist==NULL ? "NULL" : domainlist );

  if (ufdbNewGV.terminating)
     return;

  sp = ufdbNewGV.lastCat;

  if (sp->domainlistDb != NULL)
  {
     ufdbLogFatalError( "line %d: specify only one domainlist per category in configuration file %s",
		        lineno, ufdbNewGV.configFile );
     return;
  }

  dbhome = ufdbNewGV.databaseDirectory;

  if (domainlist == NULL)
  {
    name = sp->name;
    dl = (char *) ufdbMalloc( sizeof("/dest/") + strlen(name) + sizeof("/domainlist") + 2 );
    strcpy(dl,"/dest/");
    strcat(dl,name);
    strcat(dl,"/domainlist");

    sp->domainlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(dl) + 2 );
    strcpy(sp->domainlist,dbhome);
    strcat(sp->domainlist,"/");
    strcat(sp->domainlist,dl);
  }
  else
  {
    if (domainlist[0] == '/') 
      sp->domainlist = domainlist;
    else
    {
       sp->domainlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(domainlist) + 2 );
       strcpy( sp->domainlist, dbhome );
       strcat( sp->domainlist, "/" );
       strcat( sp->domainlist, domainlist );
       ufdbFree( (void*) domainlist );
    }
  }

  sp->domainlistDb = (struct sgDb *) ufdbCalloc( 1, sizeof(struct sgDb) );
  sp->domainlistDb->type = SGDBTYPE_DOMAINLIST;
  ufdbLogMessage( "loading URL table from \"%s\"", sp->domainlist );
  sgDbInit( sp->domainlistDb, sp->domainlist );
  if (sp->domainlistDb->dbcp == NULL  ||
      ((struct UFDBmemTable *) sp->domainlistDb->dbcp)->table.nNextLevels == 0)
  {
    ufdbLogError( "URL database table \"%s\" is empty and is ignored   *****", sp->domainlist );
    ufdbFreeDomainDb( sp->domainlistDb );
    sp->domainlistDb = NULL;
  }
}


static void ufdbCategoryExecDomainList( 
   char * command )
{
   struct Category * sp;

#if UFDB_DEBUG
   ufdbLogMessage( "ufdbCategoryExecDomainList %s", command );
#endif

   sp = ufdbNewGV.lastCat;

   if (sp == NULL)
   {
      ufdbLogFatalError( "execdomainlist is not within a URL category" );
      return;
   }
   sp->execdomainlist = command;

   if (ufdbGV.debug)
      ufdbLogMessage( "execdomainlist for category %s: \"%s\"", sp->name, command );
}


void ufdbFreeDomainDb( 
   struct sgDb * dbp )
{
   struct UFDBmemTable * mt;

   if (dbp == NULL)
      return;

   mt = (struct UFDBmemTable *) dbp->dbcp;
   if (mt != NULL)
   {
      if (mt->index != NULL)
      {
	 ufdbFree( mt->index );				/* version 2.x */
	 ufdbFree( mt->table.nextLevel );
      }
      else
	 UFDBfreeTableIndex_1_2( &(mt->table) ); 	/* version 1.2 */
#if HAVE_MADVISE && !UFDB_BARE_METAL_SUPPORT && __linux__
      if (mt->madvisedSize)
         madvise( mt->mem, mt->madvisedSize, MADV_NORMAL );
#endif
      if (mt->memStatus == UFDB_MEMSTATUS_MALLOC)
         ufdbFree( (void *) mt->mem );
      ufdbFree( mt );
   }
   ufdbFree( dbp );
}


void ufdbFreeIpv4List( struct Ipv4 * ipv4 )
{
   struct Ipv4 * tmp;

   while (ipv4 != NULL)
   {
      tmp = ipv4->next;
      ufdbFree( (void*) ipv4 );
      ipv4 = tmp;
   }
}


void ufdbFreeIpv6List( struct Ipv6 * ipv6 )
{
   struct Ipv6 * tmp;

   while (ipv6 != NULL)
   {
      tmp = ipv6->next;
      ufdbFree( (void*) ipv6 );
      ipv6 = tmp;
   }
}


static void ufdbFreeSourceList( struct Source * src )
{
   struct Source * tmp;

   while (src != NULL)
   {
      if (src->ipv4hosts != NULL)
         UFDBmemDBdeleteDB( src->ipv4hosts );
      ufdbFreeIpv4List( src->ipv4 );
      if (src->ipv6hosts != NULL)
         UFDBmemDBdeleteDB( src->ipv6hosts );
      ufdbFreeIpv6List( src->ipv6 );

      ufdbFree( (void*) src->name );
      if (src->domainDb != NULL)
	 UFDBmemDBdeleteDB( (struct UFDBmemDB *) src->domainDb );

      /* execuserlist content is saved during a reload except when ufdbguardd terminates */
      if (src->userDb != NULL  &&  src->userDb->type != SGDBTYPE_EXECUSERLIST)
      {
	 UFDBmemDBdeleteDB( (struct UFDBmemDB *) src->userDb->dbcp );
	 ufdbFree( (void*) src->userDb );
      }
      ufdbFree( (void*) src->sarg0 );
      ufdbFree( (void*) src->execiplistCommand );

      tmp = src->next;
      ufdbFree( (void*) src );
      src = tmp;
   }
}


static void ufdbFreeAclCategoryList( struct AclCategory * ac )
{
   struct AclCategory * tmp;

   while (ac != NULL)
   {
      ufdbFree( (void*) ac->name );
      tmp = ac->next;
      ufdbFree( (void*) ac );
      ac = tmp;
   }
}


static void ufdbFreeAclList( struct Acl * acl )
{
   struct Acl * tmp;

   while (acl != NULL)
   {
      ufdbFree( (void*) acl->name );
      ufdbFreeAclCategoryList( acl->pass );
      ufdbFreeAclCategoryList( acl->implicitPass );
      ufdbFree( (void*) acl->redirect );
      tmp = acl->next;
      ufdbFree( (void*) acl );
      acl = tmp;
   }
}


static void ufdbFreeCategoryList( struct Category * cat )
{
   struct Category * tmp;

   while (cat != NULL)
   {
      if (ufdbGV.debug > 1  ||  ufdbGV.debugRegexp)
         ufdbLogMessage( "ufdbFreeCategoryList: freeing regexp of category %s", cat->name );
      ufdbFreeRegExprList( cat->regExp );
      ufdbFree( (void*) cat->name );
      ufdbFree( (void*) cat->domainlist );
      ufdbFreeDomainDb( cat->domainlistDb );
      ufdbFree( (void*) cat->execdomainlist );
      ufdbFree( (void*) cat->expressionlist );
      ufdbFree( (void*) cat->redirect );
      /* ufdbFree( cat->rewrite );  freed in ufdbFreeRewriteList() */
      tmp = cat->next;
      ufdbFree( (void*) cat );
      cat = tmp;
   }
}


static void ufdbFreeRewriteList( 
   struct sgRewrite * p )
{
   struct sgRewrite * tmp;

   while (p != NULL)
   {
      ufdbFreeRegExprList( p->rewrite );
      ufdbFree( (void*) p->name );
      tmp = p->next;
      ufdbFree( (void*) p );
      p = tmp;
   }
}


static void ufdbFreeTimeElement( 
   struct TimeElement * p )
{
   struct TimeElement * tmp;

   while (p != NULL)
   {
      tmp = p->next;
      ufdbFree( (void*) p );
      p = tmp;
   }
}


static void ufdbFreeTime( 
   struct ufdbTime * p )
{
   struct ufdbTime * tmp;

   while (p != NULL)
   {
      ufdbFree( (void*) p->name );
      ufdbFreeTimeElement( p->element );
      tmp = p->next;
      ufdbFree( (void*) p );
      p = tmp;
   }
}


void ufdbFreeLastBits( struct ufdbGV * gv )
{
   /* we may need these variables during a reload */
   if (gv->pidFilename != NULL)
   {
      ufdbFree( (void*) gv->pidFilename );
      gv->pidFilename = NULL;
   }
   if (gv->emailServer != NULL)
   {
      ufdbFree( (void*) gv->emailServer );
      gv->emailServer = NULL;
   }
   if (gv->myHostname != NULL)
   {
      ufdbFree( (void*) gv->myHostname );
      gv->myHostname = NULL;
   }
   if (gv->adminEmail != NULL)
   {
      ufdbFree( (void*) gv->adminEmail );
      gv->adminEmail = NULL;
   }
   if (gv->senderEmail != NULL)
   {
      ufdbFree( (void*) gv->senderEmail );
      gv->senderEmail = NULL;
   }
   if (gv->externalStatusCommand != NULL)
   {
      ufdbFree( (void*) gv->externalStatusCommand );
      gv->externalStatusCommand = NULL;
   }
}


void ufdbFreeAllMemory( struct ufdbGV * gv )
{
   if (gv->logDir != NULL)
      ufdbFree( gv->logDir );
   gv->logDir = NULL;

   ufdbFreeRewriteList( gv->rewrite );
   gv->rewrite = NULL;
   gv->lastRewrite = NULL;
   gv->lastRewriteRegExec = NULL;

   ufdbFreeCategoryList( gv->catList );
   gv->catList = NULL;
   gv->lastCat = NULL;

   ufdbFreeAclList( gv->aclList );
   gv->aclList = NULL;
   gv->lastAcl = NULL;
   gv->defaultAcl = NULL;
   gv->lastAclCategory = NULL;

   ufdbFreeSourceList( (struct Source *) gv->sourceList );
   gv->sourceList = NULL;
   gv->lastSource = NULL;

   /* free ufdbNewGV.checkedDB */
   if (gv->checkedDB.mem != NULL)
   {
      if (gv->checkedDB.index != NULL)
      {
         ufdbFree( (void*) gv->checkedDB.index );
	 ufdbFree( gv->checkedDB.table.nextLevel );
      }
      else
	 UFDBfreeTableIndex_1_2( &(gv->checkedDB.table) );
#if HAVE_MADVISE && !UFDB_BARE_METAL_SUPPORT && __linux__
      if (gv->checkedDB.madvisedSize)
         madvise( gv->checkedDB.mem, gv->checkedDB.madvisedSize, MADV_NORMAL );
#endif
      gv->checkedDB.madvisedSize = 0;
      if (gv->checkedDB.memStatus == UFDB_MEMSTATUS_MALLOC)
         ufdbFree( (void*) gv->checkedDB.mem );
   }
   gv->checkedDB.table.nextLevel = NULL;
   gv->checkedDB.table.nNextLevels = 0;
   gv->checkedDB.mem = NULL;
   gv->checkedDB.index = NULL;

   if (gv->checkedExpressions != NULL)
   {
      ufdbFreeRegExprList( gv->checkedExpressions );
      gv->checkedExpressions = NULL;
   }

   ufdbFreeTime( gv->timeList );
   gv->timeList = NULL;
   gv->lastTime = NULL;

   gv->lastTimeElement = NULL;
   gv->timeElement = NULL;

   gv->lastRegExpDest = NULL;

   ufdbFree( (void*) gv->SquidVersion );
   gv->SquidVersion = NULL;
}


static void ufdbCategoryUrlList( 
   char * urllist )
{
   if (urllist == NULL)
      urllist = (char *) "-";
   ufdbLogError( "line %d: \"urllist %s\" is deprecated and ignored *****\n"
                 "ufdbGenTable should be called with the -u option to include URLs\n"
		 "ufdbGenTable combines URLs and domains in one table file so only the domainlist is required",
		 lineno, urllist );
   if (urllist[0] != '-')
      ufdbFree( (void*) urllist );
}


void ufdbCategoryExpressionList( 
  char * exprlist, 
  const char * chcase  )
{
  FILE * fp;
  char * dbhome;
  char * dl;
  const char * name;
  char * p;
  int    flags;
  struct stat         statbuf;
  struct Category *   sp;
  struct ufdbRegExp * regexp;
  char   buf[UFDB_MAX_URL_LENGTH];
  char   errbuf[256];

#if UFDB_DEBUG
   ufdbLogMessage( "ufdbCategoryExpressionList %s", exprlist );
#endif

  flags = REG_EXTENDED | REG_NOSUB;
  sp = ufdbNewGV.lastCat;
  dbhome = ufdbNewGV.databaseDirectory;

  if (exprlist == NULL)
  {
    name = sp->name;
    dl = (char *) ufdbMalloc( sizeof("/dest/") + strlen(name) + sizeof("/expressionlist") + 2 );
    strcpy(dl,"/dest/");
    strcat(dl,name);
    strcat(dl,"/expressionlist");

    flags |= REG_ICASE; 	/* default case insensitive */

    sp->expressionlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(dl) + 2 );
    strcpy(sp->expressionlist,dbhome);
    strcat(sp->expressionlist,"/");
    strcat(sp->expressionlist,dl);
  }
  else
  {
    if (exprlist[0] == '/') 
    {
      sp->expressionlist = exprlist;
    }
    else
    {
       sp->expressionlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(exprlist) + 2 );
       strcpy( sp->expressionlist, dbhome );
       strcat( sp->expressionlist, "/" );
       strcat( sp->expressionlist, exprlist );
       ufdbFree( (void*) exprlist );
    }
    if (*chcase == 'i')
       flags |= REG_ICASE;     /* set case insensitive */
  }

  ufdbLogMessage( "loading regular expressions from \"%s\"", sp->expressionlist );

  if ((fp = fopen(sp->expressionlist, "r")) == NULL) 
  {
    ufdbLogFatalError( "cannot open expression list %s: %s", sp->expressionlist, strerror(errno) );
    return;
  }

  if (0 == fstat( fileno(fp), &statbuf ))
  {
     if (!S_ISREG(statbuf.st_mode))
     {
        ufdbLogFatalError( "expression list %s: not a regular file", sp->expressionlist );
	fclose( fp );
	return;
     }
  }

  while (!feof(fp)  &&  fgets(buf, sizeof(buf), fp) != NULL) 
  {
    if (buf[0] == '#')
       continue;

    p = (char *) strchr( buf, '\n' );
    if (p != NULL  &&  p != buf) 
    {
      if (*(p-1) == '\r') 	/* removing ^M  */
	p--;
      *p = '\0';
    }
    /* TO-DO: warn about leading and trailing spaces */
    regexp = ufdbNewPatternBuffer( buf, flags );
    if (regexp->error) 
    {
      regerror( regexp->error, (regex_t*) regexp->compiled[0], errbuf, sizeof(errbuf) );
      ufdbLogError( "regular expression error in %s:\n%s : %s   *****", sp->expressionlist, errbuf, buf );
    }
    if (ufdbNewGV.lastCat->regExp == NULL) 
    {
      ufdbNewGV.lastCat->regExp = regexp;
      ufdbNewGV.lastRegExpDest = regexp;
    }
    else
    {
      ufdbNewGV.lastRegExpDest->next = regexp;
      ufdbNewGV.lastRegExpDest = regexp;
    }
  }
  fclose( fp );

  if (ufdbNewGV.expressionOptimisation)
     ufdbNewGV.lastCat->regExp = UFDBoptimizeExprList( sp->expressionlist, ufdbNewGV.lastCat->regExp );
}


static void ufdbCategoryCACertsFile(
   char *              cacertsFile )
{
   struct Category *   cat;

   cat = ufdbNewGV.lastCat;
   if (cat == NULL  ||  strcmp( cat->name, "security" ) != 0)
   {
      ufdbLogFatalError( "cacerts can only be defined inside the \"security\" category" );
      return;
   }

   if (*cacertsFile == '/')
      strcpy( ufdbNewGV.CAcertsFile, cacertsFile );
   else
   {
      char * dbh;
      dbh = ufdbNewGV.databaseDirectory;
      strcpy( ufdbNewGV.CAcertsFile, dbh );
      strcat( ufdbNewGV.CAcertsFile, "/" );
      strcat( ufdbNewGV.CAcertsFile, cacertsFile );
   }
}


static void ufdbCategoryCACertsDir(
   char *              cacertsDir )
{
   struct Category *   cat;

   cat = ufdbNewGV.lastCat;
   if (cat == NULL  ||  strcmp( cat->name, "security" ) != 0)
   {
      ufdbLogFatalError( "cacerts-dir can only be defined inside the \"security\" category" );
      return;
   }

   if (*cacertsDir == '/')
      strcpy( ufdbNewGV.CAcertsDir, cacertsDir );
   else
   {
      char * dbh;
      dbh = ufdbNewGV.databaseDirectory;
      strcpy( ufdbNewGV.CAcertsDir, dbh );
      strcat( ufdbNewGV.CAcertsDir, "/" );
      strcat( ufdbNewGV.CAcertsDir, cacertsDir );
   }
}


static void ufdbCategoryRedirect( 
   char * value )
{
   struct Category * sp;

#if UFDB_DEBUG
   ufdbLogMessage( "ufdbCategoryRedirect %s", value );
#endif

   sp = ufdbNewGV.lastCat;
   sp->redirect = value;
   /* TODO: check that "localhost" is not here if no 302 is used */
}


static void ufdbCategoryRewrite( 
  char *              value )
{
  struct sgRewrite *  rewrite;

  if ((rewrite = sgRewriteFindName(value)) == NULL)
  {
    ufdbLogFatalError( "line %d: rewrite %s is not defined in configuration file %s",
		       lineno, value, ufdbNewGV.configFile );
    return;
  }

  ufdbNewGV.lastCat->rewrite = rewrite;
}


static void ufdbCategoryBlockConnect( 
   int flag  )
{
   ufdbNewGV.lastCat->blockBumpedConnect = flag;

   if (ufdbGV.debug > 1)
      ufdbLogMessage( "ufdbCategoryBlockConnect: category \"%s\" : block-bumped-connect %s",
                      ufdbNewGV.lastCat->name, flag ? "on" : "off" );
}


static void ufdbCategoryActiveBumping( 
   int flag  )
{
   ufdbNewGV.lastCat->activeBumping = flag ? UFDB_ACTIVE_BUMPING_ON : UFDB_ACTIVE_BUMPING_OFF;

   if (ufdbGV.debug > 1)
      ufdbLogMessage( "ufdbCategoryActiveBumping: category \"%s\" : squid-uses-active-bumping %s",
                      ufdbNewGV.lastCat->name, flag ? "on" : "off" );
}


static void ufdbCategoryTime(  
   char *       name, 
   int  	within )
{
   struct ufdbTime * t;

   if ((t = sgTimeFindName(name)) == NULL) 
   {
      ufdbLogFatalError( "line %d: time \"%s\" is not defined in configuration file %s",
   		         lineno, name, ufdbNewGV.configFile );
      ufdbFree( (void*) name );
      return;
   }

   ufdbNewGV.lastCat->within = within;
   ufdbNewGV.lastCat->time = t;
   ufdbFree( (void*) name );
}


struct Category * ufdbCategoryFindByName( 
   struct ufdbGV *   gv,
   const char *      name )
{
   struct Category * p;

   for (p = gv->catList;  p != NULL;  p = p->next)
   {
      if (strcmp(name,p->name) == 0)
         return p;
   }
   return NULL;
}


static void sgRewrite( 
  char * rewrite )
{
  struct sgRewrite * rew;

#if UFDB_DEBUG
   ufdbLogMessage( "sgRewrite %s", rewrite );
#endif

  if (ufdbNewGV.rewrite != NULL)
  {
    if ((struct sgRewrite *) sgRewriteFindName(rewrite) != NULL)
    {
      ufdbLogFatalError( "line %d: rewrite \"%s\" is not defined in configuration file %s",
		         lineno, rewrite, ufdbNewGV.configFile );
      ufdbFree( (void*) rewrite );
      return;
    }
  }

  rew = (struct sgRewrite *) ufdbMalloc( sizeof(struct sgRewrite) );
  rew->name = rewrite;
  rew->active = 1;
  rew->rewrite = NULL;
  rew->time = NULL;
  rew->within = UFDB_ACL_NONE;
  rew->next = NULL;

  if (ufdbNewGV.rewrite == NULL) 
  {
    ufdbNewGV.rewrite = rew;
    ufdbNewGV.lastRewrite = rew;
  }
  else
  {
    ufdbNewGV.lastRewrite->next = rew;
    ufdbNewGV.lastRewrite = rew;
  }
}


static void sgRewriteTime( 
  char * name, 
  int    within )
{
  struct ufdbTime * t;

#if UFDB_DEBUG
   ufdbLogMessage( "sgRewriteTime %s %d", name, within );
#endif

  if ((t = sgTimeFindName(name)) == NULL)
  {
    ufdbLogFatalError( "line %d: time \"%s\" is not defined in configuration file %s",
		       lineno, name, ufdbNewGV.configFile );
    ufdbFree( (void*) name );
    return;
  }

  ufdbNewGV.lastRewrite->within = within;
  ufdbNewGV.lastRewrite->time = t;
  ufdbFree( (void*) name );
}


static void sgRewriteSubstitute( 
  char * string )
{
  char * pattern; 
  char * subst = NULL;
  char * p;
  int    flags = REG_EXTENDED;
  int    global = 0;
  char * httpcode = NULL;
  struct ufdbRegExp * regexp;
  char   errbuf[256];

  pattern = string + 2; 	/* skipping s@ */
  p = pattern;
  while ((p = strchr(p,'@')) != NULL)
  {
    if (*(p - 1) != '\\') 
    {
      *p = '\0';
      subst = p + 1;
      break;
    }
    p++;
  }

  p = strrchr( subst, '@' );
  while (p != NULL  &&  *p != '\0')
  {
    if (*p == 'r' )
      httpcode =  (char *) REDIRECT_TEMPORARILY;
    if (*p == 'R' )
      httpcode =  (char *) REDIRECT_PERMANENT;
    if (*p == 'i' || *p == 'I')
      flags |= REG_ICASE;
    if (*p == 'g')
      global = 1;
    *p = '\0'; 		/* removes @i from string */
    p++;
  } 

  regexp = ufdbNewPatternBuffer( pattern, flags );
  if (regexp->error) 
  {
      regerror( regexp->error, (regex_t*) regexp->compiled[0], errbuf, sizeof(errbuf) );
      ufdbLogError( "line %d: regular expression error in %s:\n%s   *****", lineno, pattern, errbuf );
  }
  else {
    regexp->substitute = ufdbStrdup( subst );
  }

  if (ufdbNewGV.lastRewrite->rewrite == NULL)
    ufdbNewGV.lastRewrite->rewrite = regexp;
  else 
    ufdbNewGV.lastRewriteRegExec->next = regexp;
  regexp->httpcode = httpcode;
  regexp->global = global;
  ufdbNewGV.lastRewriteRegExec = regexp;
}


static struct sgRewrite * sgRewriteFindName( 
   const char * name )
{
   struct sgRewrite * p;

   for (p = ufdbNewGV.rewrite;  p != NULL;  p = p->next)
   {
      if (strcmp(name,p->name) == 0)
         return p;
   }
   return NULL;
}


/*
 * Time functions
 */

/*
 * sgTime - parse configuration time statement.
 */
static void sgTime( 
  char *        name )
{
  struct ufdbTime * t;

  if (ufdbGV.debug > 1)
     ufdbLogMessage( "sgTime %s", name );

  if (ufdbNewGV.timeList != NULL)
  {
    if ((struct ufdbTime *) sgTimeFindName(name) != NULL)
    {
      ufdbLogFatalError( "line %d: time \"%s\" is not defined in configuration file %s",
		         lineno, name, ufdbNewGV.configFile );
      ufdbFree( (void*) name );
      return;
    }
  }
  else 
    numTimeElements = 0;

  t = (struct ufdbTime *) ufdbMalloc( sizeof(struct ufdbTime) );
  t->name = name;
  t->active = 1;
  t->element = NULL;
  t->next = NULL;

  ufdbNewGV.timeElement = NULL;
  ufdbNewGV.lastTimeElement = NULL;
  if (ufdbNewGV.timeList == NULL) 
  {
    ufdbNewGV.timeList = t;
    ufdbNewGV.lastTime = t;
  }
  else
  {
    ufdbNewGV.lastTime->next = t;
    ufdbNewGV.lastTime = t;
  }
}


/*
 * sgTimeElementInit - initialise parsing of a configuration time element.
 */
static void sgTimeElementInit( void )
{
   struct TimeElement * te;

   te = (struct TimeElement *) ufdbCalloc( 1, sizeof(struct TimeElement) );
   numTimeElements++;

   if (ufdbNewGV.lastTime->element == NULL)
     ufdbNewGV.lastTime->element = te;
   if (ufdbNewGV.lastTimeElement != NULL)
     ufdbNewGV.lastTimeElement->next = te;
   ufdbNewGV.lastTimeElement = te;
}


/*
 * sgTimeElementEnd - finalise parsing of configuration time element.
 */
static void sgTimeElementEnd( void )
{
  time_switch = 0;
  date_switch = 0;

  if (ufdbNewGV.lastTimeElement->fromdate != 0)
  {
    if (ufdbNewGV.lastTimeElement->todate == 0)
      ufdbNewGV.lastTimeElement->todate = ufdbNewGV.lastTimeElement->fromdate + 86399;
    else 
      ufdbNewGV.lastTimeElement->todate = ufdbNewGV.lastTimeElement->todate + 86399;
  }

  if (ufdbNewGV.lastTimeElement->from == 0  &&  ufdbNewGV.lastTimeElement->to == 0)
    ufdbNewGV.lastTimeElement->to = 1439;  /* set time to 23:59 */
}


/*
 * sgTimeElementAdd - add configuration time element.
 */
static void sgTimeElementAdd( 
  char * element, 
  char   type ) 
{
  struct TimeElement * te;
  char * p;
  char   wday;
  int    h, m, Y, M, D;
  time_t sec;
  char * lineptr;

  wday = 0;
  M = 0;
  D = -1;
  te = ufdbNewGV.lastTimeElement;

  switch (type)
  {
  case T_WEEKDAY:
    p = strtok_r( element, " \t,", &lineptr );
    do {
      if (*p == '*') {
	wday = 0x7F;
      } else if (!strncmp(p,"sun",3)) {
	wday = wday | 0x01;
      } else if (!strncmp(p,"mon",3)) {
	wday = wday | 0x02;
      } else if (!strncmp(p,"tue",3)) {
	wday = wday | 0x04;
      } else if (!strncmp(p,"wed",3)) {
	wday = wday | 0x08;
      } else if (!strncmp(p,"thu",3)) {
	wday = wday | 0x10;
      } else if (!strncmp(p,"fri",3)) {
	wday = wday | 0x20;
      } else if (!strncmp(p,"sat",3)) {
	wday = wday | 0x40;
      }
      p = strtok_r( NULL, " \t,", &lineptr );
    } while (p != NULL);
    te->wday = wday;
    break;

  case T_TVAL:
    h = -1;
    m = -1;
    sscanf( element, "%d:%d", &h, &m );
    if ((h < 0 || h > 24) || (m < 0 || m > 59))
    {
      ufdbLogFatalError( "line %d: time format error in %s", lineno, ufdbNewGV.configFile );
      h = 0;
      m = 0;
    }
    if (time_switch == 0) 
    {
      time_switch++;
      te->from = (h * 60) + m ;
    }
    else
    {
      time_switch = 0;
      te->to = (h * 60) + m ;
    }
    break;

  case T_DVAL:
    sec = date2sec( element );
    if (sec == -1) 
    {
      ufdbLogFatalError( "line %d: date format error in %s", lineno, ufdbNewGV.configFile );
      sec = 1;
    }
    if (date_switch == 0) {
      date_switch++;
      te->fromdate = sec;
    } else {
      date_switch = 0;
      te->todate = sec;
    }
    break;

  case T_DVALCRON:
    p = strtok_r( element, "-./", &lineptr );
    Y = atoi(p);
    if (*p == '*')
      Y = -1;
    else
      Y = atoi(p);
    while ((p=strtok_r(NULL,"-./",&lineptr)) != NULL) 
    {
      if (*p == '*')
	if (M == 0)
	  M = -1;
	else 
	  D = -1;
      else
	if (M == 0)
	  M = atoi(p);
	else
	  D = atoi(p);
    }
    te->y = Y;
    te->m = M;
    te->d = D;
    break;

  case T_WEEKLY:
    p = element;
    while (*p != '\0') 
    {
      switch (*p) {
      case 'S':
      case 's':
	wday = wday | 0x01;
	break;
      case 'M':
      case 'm':
	wday = wday | 0x02;
	break;
      case 'T':
      case 't':
	wday = wday | 0x04;
	break;
      case 'W':
      case 'w':
	wday = wday | 0x08;
	break;
      case 'H':
      case 'h':
	wday = wday | 0x10;
	break;
      case 'F':
      case 'f':
	wday = wday | 0x20;
	break;
      case 'A':
      case 'a':
	wday = wday | 0x40;
	break;
      default:
	ufdbLogFatalError( "line %d: weekday format error in %s", lineno, ufdbNewGV.configFile );
	break;
      }
      p++;
    }
    te->wday = wday;
    break;
  }

  ufdbFree( (void*) element );
}


/* 
 * lookup a ufdbTime element by name.
 */
static struct ufdbTime * sgTimeFindName( 
   const char * name )
{
   struct ufdbTime * p;

   for (p = ufdbNewGV.timeList;  p != NULL;  p = p->next)
   {
      if (strcmp(name,p->name) == 0)
         return p;
   }
   return NULL;
}


/*
 * sgTimeCmp - Time array sort function.
 */
static int sgTimeCmp( const void * a, const void * b )
{
   const int * aa = (const int *) a;
   const int * bb = (const int *) b;

   return *aa - *bb;
}


/*
 * _getSortedTimeElementTimes - produce a sorted array of time element times
 */
static void _getSortedTimeElementTimes( void )           // uses ufdbGV
{
   struct ufdbTime *    p;
   struct TimeElement * te;
   int                  i, j;
   int                  totalNumElems;
 
   if (ufdbGV.debug > 1)
      ufdbLogMessage( "_getSortedTimeElementEvents" );

   if (ufdbGV.timeList == NULL)
      return;

   /* find total number of time elements */
   totalNumElems = 0;
   for (p = ufdbGV.timeList;  p != NULL;  p = p->next) 
      for (te = p->element;  te != NULL;  te = te->next) 
         totalNumElems++;

   TimeElementsEvents = (int *) ufdbCalloc( totalNumElems * 2 , sizeof(int) ); 

   i = 0;
   for (p = ufdbGV.timeList;  p != NULL;  p = p->next) 
   {
      for (te = p->element;  te != NULL;  te = te->next) 
      {
         TimeElementsEvents[i++] = te->from == 0 ? 1440 : te->from;
         TimeElementsEvents[i++] = te->to == 0   ? 1440 : te->to;
      }
   }
 
   qsort( TimeElementsEvents, totalNumElems * 2, sizeof(int), sgTimeCmp );

   if (ufdbGV.debug > 1)
      ufdbLogMessage( "   _getSortedTimeElementEvents: after qsort" );

   /* remove identical time elements */
   for (i=1,j=1;  i < totalNumElems * 2;  i++) 
   {
      if (TimeElementsEvents[i] > TimeElementsEvents[i-1])
      {
	 TimeElementsEvents[j] = TimeElementsEvents[i];
         j++;
      }
   }

   numTimeElements = j;			/* #unique time elements */
}


/*
 * _TimeEvaluateElements - evaluate all elements if they match the current time/date and mark them active.
 */
static void _TimeEvaluateElements(              // uses ufdbGV
  struct tm * tm_now, 
  time_t      now )
{
  struct ufdbTime *    tlist;
  struct TimeElement * te;
  int                  min;

  if (ufdbGV.debug > 1)
     ufdbLogMessage( "      _TimeEvaluateElements" );

  for (tlist = ufdbGV.timeList;  tlist != NULL;  tlist = tlist->next)
  {
    tlist->active = 0;
    for (te = tlist->element;  te != NULL;  te = te->next)
    {
      if (te->wday != 0) 			/* check wday */
      {
	if (((1 << tm_now->tm_wday) & te->wday) != 0)  
	{
	  min = (tm_now->tm_hour * 60) + tm_now->tm_min;
	  if (min >= te->from  &&  min < te->to) 
	  {
	    tlist->active = 1;
	    break;
	  }
	}
      }
      else if (te->fromdate != 0)		/* check date */
      {
	if (now >= te->fromdate  &&  now <= te->todate) 
	{
	  min = (tm_now->tm_hour * 60) + tm_now->tm_min;
	  if (min >= te->from  &&  min < te->to) 
	  {
	    tlist->active = 1;
	    break;
	  }
	}
      }
      else					/* check crondate */
      {
	if (te->y == -1  ||  te->y == (tm_now->tm_year + 1900)) 
	{
	  if (te->m == -1  ||  te->m == (tm_now->tm_mon + 1)) 
	  {
	    if (te->d == -1  ||  te->d == (tm_now->tm_mday)) 
	    {
	      min = (tm_now->tm_hour * 60) + tm_now->tm_min;
	      if (min >= te->from  &&  min < te->to) 
	      {
		tlist->active = 1;
		break;
	      }
	    }
	  }
	}
      }
    }
    if (ufdbGV.debug > 1)
       ufdbLogMessage( "      _TimeEvaluateElements: time %s is %sactive", tlist->name, tlist->active?"":"not " );
  }
}


/*
 * _TimeSetAclSrcDestRew - mark all acl/source/dest/rew (in)active.
 */
static void _TimeSetAclSrcDestRew( void )               // uses ufdbGV
{
  struct Acl *         acl;
  struct Category *    cat;
  struct Source *      s;
  struct sgRewrite *   rew;
  int                  a;

  if (ufdbGV.debug > 1)
     ufdbLogMessage( "   _TimeSetAclSrcDestRew" );

  for (acl = ufdbGV.aclList;  acl != NULL;  acl = acl->next)
  {
    if (acl->time != NULL  &&  acl->within != UFDB_ACL_ELSE) 
    {
      /* Be careful here: we are multithreaded and other threads use the value 
       * of acl->active at the same time.
       */
      a = acl->time->active;
      if (acl->within == UFDB_ACL_OUTSIDE)
	a = !a;
      if (acl->next != NULL  &&  acl->next->within == UFDB_ACL_ELSE) 
	acl->next->active = !a;
      acl->active = a;
    }
#if 0
    if (acl->pass == NULL)
       acl->active = 0;			/* it can have a 'continue' so do not make it inactive */
#endif
    if (ufdbGV.debug > 1)
       ufdbLogMessage( "      _TimeSetAclSrcDestRew: acl %s %s is %sactive", acl->name, 
		       acl->within==UFDB_ACL_ELSE ? "ELSE" :
			  acl->within==UFDB_ACL_WITHIN ? "WITHIN" :
			     acl->within==UFDB_ACL_OUTSIDE ? "OUTSIDE" : "",
		       acl->active?"":"not " );
  }

  for (cat = ufdbGV.catList;  cat != NULL;  cat = cat->next)
  {
    if (cat->time != NULL) 
    {
      cat->active = cat->time->active;
      if (cat->within == UFDB_ACL_OUTSIDE)
	cat->active = !cat->active;
    }
    if (ufdbGV.debug > 1)
       ufdbLogMessage( "      _TimeSetAclSrcDestRew: category %s is %sactive", cat->name, cat->active?"":"not " );
  }

  for (s = ufdbGV.sourceList;  s != NULL;  s = s->next)
  {
    if (s->time != NULL) 
    {
      s->active = s->time->active;
      if (s->within == UFDB_ACL_OUTSIDE)
	s->active = !s->active;
    }
    if (ufdbGV.debug > 1)
       ufdbLogMessage( "      _TimeSetAclSrcDestRew: source %s is %sactive", s->name, s->active?"":"not " );
  }

  for (rew = ufdbGV.rewrite; rew != NULL; rew = rew->next)
  {
    if (rew->time != NULL) 
    {
      rew->active = rew->time->active;
      if (rew->within == UFDB_ACL_OUTSIDE)
	 rew->active = !rew->active;
    }
    if (ufdbGV.debug > 1)
       ufdbLogMessage( "      _TimeSetAclSrcDestRew: rewrite %s is %sactive", rew->name, rew->active?"":"not " );
  }
}


static void sgAlarm( int s )
{
   if (s) { ; }         // prevent compiler warning
   // do nothing; there is a thread that waits for a SIGALRM which calls ufdbHandleAlarmForTimeEvents()
}


/*
 *  ufdbHandleAlarmForTimeEvents - the alarm for the next time event went off so 
 *                                 recalculate the time-dependent active state.
 */
void ufdbHandleAlarmForTimeEvents(              // uses ufdbGV
   int        why )
{
   time_t     now;
   struct tm  tm_now;
   int        m;
   int        tindex;
   int        lastval;

   if (ufdbGV.debug)
      ufdbLogMessage( "ufdbHandleAlarmForTimeEvents( why=%s )", why==UFDB_PARAM_INIT ? "init" : "alarm" );

   if (why == UFDB_PARAM_INIT)
      ufdbLogMessage( "time definitions are used; evaluating current ACLs" );
   else
   {
      ufdbLogMessage( "alarm went off to recalculate time ACLs" );
      if (ufdbGV.terminating)
      {
	 ufdbLogMessage( "This alarm is ignored because ufdbguardd is exiting" );
	 return;
      }
      if (ufdbGV.reconfig)
      {
	 ufdbLogMessage( "This alarm is ignored because the configuration is being reloaded"
	                 " and a new alarm is set to go off in 15 seconds" );
	 alarm( 15 );
	 return;
      }
   }

   if (ufdbGV.timeList == NULL)
   {
      return;
   }

   // NOTE: _getSortedTimeElementTimes() mallocs TimeElementsEvents[] and this function frees it.
   _getSortedTimeElementTimes();

   now = UFDBtime() + 30;
   localtime_r( &now, &tm_now ); 
   m = (tm_now.tm_hour * 60) + tm_now.tm_min;
  
   lastval = 0;
   for (tindex = 0;  tindex < numTimeElements;  tindex++)
   {
#if UFDB_TIME_DEBUG
      if (ufdbGV.debug > 1)
         ufdbLogMessage( "   TimeElementsEvents[%d] = %d", tindex, TimeElementsEvents[tindex] );
#endif
      lastval = TimeElementsEvents[tindex];
      if (TimeElementsEvents[tindex] >= m)
         break;
   }

   if (ufdbGV.debug > 1)
      ufdbLogMessage( "   ufdbHandleAlarmForTimeEvents: m = %d  tindex = %d, lastval = %d", m, tindex, lastval );

   if (lastval < m)
      m = (((1440 - m) + TimeElementsEvents[0]) * 60) - tm_now.tm_sec;
   else
      m = ((lastval - m) * 60) - tm_now.tm_sec;

   if (m <= 0)
      m = 30;

   _TimeEvaluateElements( &tm_now, now );
   _TimeSetAclSrcDestRew();

   ufdbFree( (void*) TimeElementsEvents );
   TimeElementsEvents = NULL;

   ufdbLogMessage( "next alarm is in %d seconds", (unsigned int) m );
   ufdbSetSignalHandler( SIGALRM, sgAlarm );
   (void) alarm( (unsigned int) m );
}


/*
 * sgTimeElementClone - copy a time specification.
 */
static void sgTimeElementClone( void )
{
  struct TimeElement * te;
  struct TimeElement * tmp;

  te = ufdbNewGV.lastTimeElement;
  if (te == NULL) 
  {
    ufdbLogFatalError( "No previous TimeElement in sgTimeElementClone !" );
    return;
  }
  else
  {
    sgTimeElementInit();
    ufdbNewGV.lastTimeElement->wday = te->wday;
    ufdbNewGV.lastTimeElement->from = te->from;
    ufdbNewGV.lastTimeElement->to = te->to;
    ufdbNewGV.lastTimeElement->y = te->y;
    ufdbNewGV.lastTimeElement->m = te->m;
    ufdbNewGV.lastTimeElement->d = te->d;
    ufdbNewGV.lastTimeElement->fromdate = te->fromdate;
    ufdbNewGV.lastTimeElement->todate = te->todate;
    tmp = ufdbNewGV.lastTimeElement;
    ufdbNewGV.lastTimeElement = te;
    sgTimeElementEnd();
    ufdbNewGV.lastTimeElement = tmp;
  }
}


/*
 * IP functions
 */

static struct Ipv4 * sgIpv4Last( 
   struct Source * s )
{
   struct Ipv4 * ipv4;
   struct Ipv4 * last;

   last = NULL;
   for (ipv4 = s->ipv4;  ipv4 != NULL;  ipv4 = ipv4->next)
      last = ipv4;

   return last;
}


static void sgIpv4( 
   const char *   addr,
   int            type,
   const char *   file,
   int            lineno )
{
   struct Ipv4 *  ipv4;
   char *         addr2;
   char *         cidr;
   char *         end;
   unsigned int   octet;

#if 1
   if (ufdbGV.debug> 1)
      ufdbLogMessage( "   sgIpv4( %s %d %s %d )", addr, type, file, lineno );
#endif

   switch (type)
   {
   case SG_IPTYPE_HOST:
	 if (ufdbNewGV.lastSource->ipv4hosts == NULL)
	    ufdbNewGV.lastSource->ipv4hosts = UFDBmemDBinit();
	 UFDBmemDBinsert( ufdbNewGV.lastSource->ipv4hosts, addr, NULL );
  	 break;

   case SG_IPTYPE_RANGE:
	 addr2 = strchr( addr, '-' );
	 *addr2 = '\0';
	 end = addr2;
	 while (*(end-1) == ' '  ||  *(end-1) == '\t')
	 {
	    *(end-1) = '\0';
	    end--;
	 }
	 addr2++;
	 while (*addr2 == ' ' || *addr2 == '\t')
	    addr2++;

         ipv4 = (struct Ipv4 *) ufdbMalloc( sizeof(struct Ipv4) );
	 ipv4->type = SG_IPTYPE_RANGE;
         ipv4->net_is_set = 1;
	 ipv4->next = NULL;
	 if (ufdbNewGV.lastSource->ipv4 == NULL) 
	    ufdbNewGV.lastSource->ipv4 = ipv4;
	 else
	    sgIpv4Last( ufdbNewGV.lastSource )->next = ipv4;

	 if (sgConvDot(addr,&ipv4->net) == NULL)
	 {
	    ufdbLogFatalError( "IPv4 address error in %s line %d: %s - %s", file, lineno, addr, addr2 );
	    ipv4->net = 0;
	    ipv4->net_is_set = 0;
	 }
	 if (sgConvDot(addr2,&ipv4->mask) == NULL)
	 {
	    ufdbLogFatalError( "IPv4 address error in %s line %d: %s - %s", file, lineno, addr, addr2 );
	    ipv4->mask = 0;
	    ipv4->net_is_set = 0;
	 }

	 if ((unsigned int) ipv4->net > (unsigned int) ipv4->mask)
	     ufdbLogFatalError( "IPv4 range error in %s line %d: %s - %s", file, lineno, addr, addr2 );
  	 break;

   case SG_IPTYPE_CLASS:
	 addr2 = strchr( addr, '/' );
	 *addr2 = '\0';
	 addr2++;
         ipv4 = (struct Ipv4 *) ufdbMalloc( sizeof(struct Ipv4) );
	 ipv4->type = SG_IPTYPE_CLASS;
         ipv4->net_is_set = 1;
	 ipv4->next = NULL;
	 if (ufdbNewGV.lastSource->ipv4 == NULL) 
	    ufdbNewGV.lastSource->ipv4 = ipv4;
	 else
	    sgIpv4Last( ufdbNewGV.lastSource )->next = ipv4;

	 if (sgConvDot(addr,&ipv4->net) == NULL)
	 {
	    ufdbLogFatalError( "IPv4 address error in %s line %d: %s/%s", file, lineno, addr, addr2 );
	    ipv4->net = 0;
	    ipv4->net_is_set = 0;
	 }
	 if (sgConvDot(addr2,&ipv4->mask) == NULL)
	 {
	    ufdbLogFatalError( "IPv4 address error in %s line %d: %s/%s", file, lineno, addr, addr2 );
	    ipv4->mask = 0;
	 }
  	 break;

   case SG_IPTYPE_CIDR:
	 cidr = strchr( addr, '/' );
	 *cidr = '\0';
	 cidr++;
	 octet = (unsigned long) atoi( cidr );
	 if (octet > 32) 
	 {
	    ufdbLogFatalError( "IPv4 address CIDR out of range in %s line %d: %s/%s",
	                       file, lineno, addr, cidr );
	    octet = 32;
	 }
         ipv4 = (struct Ipv4 *) ufdbMalloc( sizeof(struct Ipv4) );
	 ipv4->type = SG_IPTYPE_CIDR;
         ipv4->net_is_set = 1;
	 ipv4->next = NULL;
	 if (ufdbNewGV.lastSource->ipv4 == NULL) 
	    ufdbNewGV.lastSource->ipv4 = ipv4;
	 else
	    sgIpv4Last( ufdbNewGV.lastSource )->next = ipv4;

	 if (sgConvDot(addr,&ipv4->net) == NULL)
	 {
	    ufdbLogFatalError( "IPv4 address error in %s line %d: %s/%s", file, lineno, addr, cidr );
	    ipv4->net = 0;
	    ipv4->net_is_set = 0;
	 }
	 if (octet == 32)
	    ipv4->mask = 0xffffffff;
	 else
	    ipv4->mask = 0xffffffff ^ (0xffffffff >> octet);
	 ipv4->net = ipv4->net & ipv4->mask;
  	 break;
   }
}


static struct Ipv6 * sgIpv6Last( 
   struct Source * s )
{
   struct Ipv6 * ipv6;
   struct Ipv6 * last;

   last = NULL;
   for (ipv6 = s->ipv6;  ipv6 != NULL;  ipv6 = ipv6->next)
      last = ipv6;

   return last;
}



static void sgIpv6( 
   const char * addr,
   int          type,
   const char * file,
   int          line  )
{
#if 1
   if (ufdbGV.debug > 1)
      ufdbLogMessage( "   sgIpv6( %s %d  %s %d/%d )", addr, type, file, line, lineno );
#endif

   if (type == SG_IPV6TYPE_HOST)
   {
      struct in6_addr dummy;
      if (!sgValidateIPv6( addr, &dummy ))
      {
         ufdbLogFatalError( "incorrect IPv6 address \"%s\" in %s line %d", addr, file, lineno );
      }
      else
      {
         if (ufdbNewGV.lastSource->ipv6hosts == NULL)
	    ufdbNewGV.lastSource->ipv6hosts = UFDBmemDBinit();
	 UFDBmemDBinsert( ufdbNewGV.lastSource->ipv6hosts, addr, NULL );
      }
   }
   else if (type == SG_IPV6TYPE_CIDR)
   {
      char * s = (char*) strchr( addr, '/' );
      if (s == NULL)
      {
         ufdbLogFatalError( "IPv6 net has no '/' in \"%s\" in %s line %d", addr, file, lineno );
      }
      else
      {
	 struct Ipv6 *  ipv6;

	 ipv6 = (struct Ipv6 *) ufdbMalloc( sizeof(struct Ipv6) );
	 ipv6->type = SG_IPV6TYPE_CIDR;
	 ipv6->next = NULL;
	 if (ufdbNewGV.lastSource->ipv6 == NULL) 
	    ufdbNewGV.lastSource->ipv6 = ipv6;
	 else
	    sgIpv6Last( ufdbNewGV.lastSource )->next = ipv6;

         *s = '\0';
         ipv6->cidr = (unsigned long) atoi( s+1 );
         if (ipv6->cidr < 1  ||  ipv6->cidr > 128) 
         {
            ufdbLogFatalError( "IPv6 address CIDR out of range \"%s\" in %s line %d", addr, file, lineno );
            ipv6->cidr = 128;
         }
         if (!sgValidateIPv6( addr, &ipv6->ipv6 ))
         {
            ufdbLogFatalError( "incorrect IPv6 address \"%s\" in %s line %d", addr, file, lineno );
         }
         *s = '/';
      }
   }
   else
   {
      ufdbLogFatalError( "sgIpv6 called with unsupported type %d in %s line %d: %s", type, file, lineno, addr );
   }
}


/*
 * ACL functions
 */

static void ufdbAcl( 
   const char *    name,
   const char *    value, 
   int             within )
{
   struct Acl *    acl;
   struct Source * source;

#if UFDB_DEBUG
   ufdbLogMessage( "ufdbAcl name=\"%s\" value=\"%s\" within=%d line=%d", 
                   name==NULL?"NULL":name,  value==NULL?"NULL":value, within, lineno );
#endif

   if (ufdbNewGV.aclList != NULL) 
   {
      if (ufdbAclFindByName(&ufdbNewGV,name) != NULL)
      {
	 ufdbLogFatalError( "line %d: ACL \"%s\" is already defined in configuration file %s",
			    lineno, name, ufdbNewGV.configFile );
      }
   }

   if (within == UFDB_ACL_ELSE)
   {
      if (ufdbNewGV.lastAcl == NULL)
      {
         ufdbLogFatalError( "line %d: ACL \"else\" has no parent ACL", lineno );
         return;
      }
      if (name == NULL)
         name = ufdbStrdup( ufdbNewGV.lastAcl->name );
   }

   acl = (struct Acl *) ufdbMalloc( sizeof(struct Acl) );

   source = NULL;
   if (strcmp(name,"default") == 0)
   {
      ufdbNewGV.defaultAcl = acl;
   }
   else
   {
      if ((source = defSourceFindName(ufdbNewGV.sourceList,name)) == NULL)
      {
         ufdbLogFatalError( "line %d: ACL source \"%s\" is not defined in configuration file %s",
                            lineno, name, ufdbNewGV.configFile );
         if (ufdbNewGV.fastRefresh  &&  ufdbGV.fastRefresh  &&
             defSourceFindName(ufdbGV.sourceList,name) != NULL)
            ufdbLogError( "But ACL source \"%s\" is defined in the old configuration  *****", name );
         if (ufdbGV.debug > 1)
            UFDBlogConfig( &ufdbGV );
         ufdbFree( (void*) name );
         ufdbFree( (void*) acl );
         return;
      }
   }

   acl->name = name;
   acl->active = within == UFDB_ACL_ELSE ? 0 : 1;
   acl->source = source;
   acl->pass = NULL;
   acl->implicitPass = NULL;
   acl->hasTerminatorNone = 0;
   acl->rewriteDefault = 1;
   acl->rewrite = NULL;
   acl->redirect = NULL;
   acl->time = NULL;
   acl->within = within;
   acl->next = NULL;

   if (value != NULL) 
   {
      struct ufdbTime * t;
      if ((t = sgTimeFindName(value)) == NULL) 
      {
         ufdbLogFatalError( "line %d: ACL time %s is not defined in configuration file %s",
                            lineno, value, ufdbNewGV.configFile );
         return;
      }
      acl->time = t;
   }

   if (ufdbNewGV.aclList == NULL) 
   {
      ufdbNewGV.aclList = acl;
      ufdbNewGV.lastAcl = acl;
   }
   else
   {
      ufdbNewGV.lastAcl->next = acl;
      ufdbNewGV.lastAcl = acl;
   }
}


static void ufdbAclSetValue( 
  const char *         what,
  const char *         value, 
  int                  allowed ) 
{
  struct Category *    cat = NULL;
  struct AclCategory * aclcat;
  int                  type;
  
#if UFDB_DEBUG
   ufdbLogMessage( "ufdbAclSetValue %s %s%s", what, allowed ? "" : "!", value );
#endif

  if (ufdbNewGV.lastAcl == NULL)
  {
     ufdbLogError( "error in configuration file on line %d: "
                   "cannot set value for \"%s\" because there is no defined ACL", 
                   lineno, what );
     ufdbFree( (void*) value );
     return;
  }

  type = ACL_TYPE_TERMINATOR;

  if (strcmp(what,"pass") == 0)
  {
    if (strcmp(value,"any")==0 || strcmp(value,"all")==0)
    {
       if (!allowed)
          ufdbLogFatalError( "error in configuration file on line %d: do not use '!any' or '!all'.  "
                             "Use 'none' instead.", lineno );
       allowed = 1;
    }
    else if (strcmp(value,"none") == 0)
    {
       if (!allowed)
          ufdbLogFatalError( "error in configuration file on line %d: do not use '!none'.  "
                             "Use 'any' instead.", lineno );
       allowed = 0;
    }
    else if (strcmp(value,"in-addr") == 0) {
      type = ACL_TYPE_INADDR;
    }
    else
    {
      if ((cat = ufdbCategoryFindByName(&ufdbNewGV,value)) == NULL) 
      {
	 ufdbLogFatalError( "ACL category \"%s\" (line %d) is not defined in configuration file %s",
			    value, lineno, ufdbNewGV.configFile );
         if (ufdbNewGV.fastRefresh  &&  ufdbGV.fastRefresh  &&
             ufdbCategoryFindByName(&ufdbGV,value) != NULL)
            ufdbLogError( "But category \"%s\" is defined in the old configuration  *****", value );
         if (ufdbGV.debug > 1)
            UFDBlogConfig( &ufdbGV );
	 ufdbFree( (void*) value );
         return;
      } 
      type = ACL_TYPE_DEFAULT;
    }

    aclcat = (struct AclCategory *) ufdbMallocAligned( UFDB_CACHELINE_SIZE, sizeof(struct AclCategory) );
    aclcat->name = value;
    aclcat->cat = cat;
    aclcat->access = allowed;
    aclcat->type = type;
    aclcat->next = NULL;
    aclcat->nblocks = 0;
    aclcat->nmatches = 0;

    if (ufdbNewGV.lastAcl->pass == NULL) {
      ufdbNewGV.lastAcl->pass = aclcat;
    } else {
      ufdbNewGV.lastAclCategory->next = aclcat;
    }
    ufdbNewGV.lastAclCategory = aclcat;
  }
  else if (strcmp(what,"redirect") == 0)
  {
    if (strcmp(value,"default") != 0)
    {
      ufdbNewGV.lastAcl->redirect = value;
    }
    else 
    {
      ufdbNewGV.lastAcl->redirect = NULL;
      ufdbFree( (void*) value );
    }
  }
  else if (strcmp(what,"rewrite") == 0)
  {
    if (strcmp(value,"none") == 0)
    {
      ufdbNewGV.lastAcl->rewriteDefault = 0;
      ufdbNewGV.lastAcl->rewrite = NULL;
    }
    else
    {
      struct sgRewrite * rewrite;

      if ((rewrite = sgRewriteFindName(value)) == NULL) 
      {
	ufdbLogFatalError( "rewrite %s is not defined in configuration file %s",
			   value, ufdbNewGV.configFile );
      }
      ufdbNewGV.lastAcl->rewriteDefault = 0;
      ufdbNewGV.lastAcl->rewrite = rewrite;
    }
    ufdbFree( (void*) value );
  }
}


struct Acl * ufdbAclFindByName( 
  struct ufdbGV * gv,
  const char *    name )
{
  struct Acl * p;

  if (name == NULL)
     return NULL;

  for (p = gv->aclList;  p != NULL;  p = p->next)
  {
    if (strcmp(name,p->name) == 0)
      return p;
  }

  return NULL;
}


static void logConfig( void )
{
   int    lno;
   FILE * fin;
   char   line[32678];
   
   if (ufdbNewGV.configLogged)
      return;
   ufdbNewGV.configLogged = 1;

   fin = fopen( ufdbNewGV.configFile, "r" );
   if (fin == NULL)
      return;

   ufdbLogMessage( "======== literal content of config file ========" );
   lno = 1;
   while (UFDBfgetsNoNL(line,sizeof(line)-1,fin) != NULL)
   {
      ufdbLogMessage( "%04d: %s", lno, line );
      lno++;
   }
   ufdbLogMessage( "======== end of literal content ========" );
   fclose( fin );
}


void yyerror( const char * s )
{
   ufdbLogFatalError( "line %d: %s in configuration file %s", lineno, s, ufdbNewGV.configFile );
}


int yywrap()
{
  return 1;
}

